export interface IDataFrame<T> {
    Resource?: string;
    TransactionId?: string;
    Data?: T;
    Status?: Status;
    Method?: Method;
}
export declare class DataFrame<T> implements IDataFrame<T> {
    Resource?: string;
    TransactionId?: string;
    Data?: T;
    Status?: Status;
    Method?: Method;
}
export declare enum Status {
    OK = 0,
    UnknownError = 1,
    FatalError = 2,
    WrongData = 3,
    ResourceDoesNotExists = 4,
    NoPermissionToPerformThisOperation = 5,
    SessionHasAlreadyLoggedOnUser = 6,
    OperationNotPermitted = 7,
    NoPermissionsToCallGivenResource = 8,
    ResourceIsNotAvailable = 9,
    Error = 10,
    NoData = 11,
    NotSupportedMethod = 12,
    UserIsNotLoggedIn = 13,
    MultiDataResponseStart = 14,
    MultiDataResponse = 15,
    MultiDataResponseStop = 16
}
export declare enum Method {
    Get = 0,
    Post = 1,
    Delete = 2,
    Put = 3,
    Options = 4,
    Head = 5
}
