import { IEvent } from "../Event";
import { ITypedEvent } from "../TypedEvent";
import { AppState, IAppStateService } from "./IAppStateService";
export declare class AppStateService implements IAppStateService {
    private _syncLock;
    private _isInFouces;
    private _canHibernate;
    private _session;
    private _connection;
    private _currentAppState;
    private _returnedFromSuspension;
    static readonly ServiceName: string;
    private _onReturnedFromSuspensionEvent;
    private _onSuspendedEvent;
    private _onEnterLowPowerModeEvent;
    private _onExitLowPowerModeEvent;
    private _onBackButtonPressedEvent;
    private _onForwardButtonPressedEvent;
    private _onAppStateChanged;
    constructor();
    private MonitorAppState;
    get CurrentAppState(): AppState;
    OnAppStateChanged(): ITypedEvent<AppState>;
    Suspend(): void;
    ReturnFromSuspension(): void;
    EnterLowPowerMode(): void;
    ExitLowPowerMode(): void;
    IsWorkingInWebView(): boolean;
    private IsHidden;
    IsActive(): boolean;
    IsInBackground(): boolean;
    ReturnedFromSuspension(): boolean;
    IsHibernationAllowed(): boolean;
    DisallowHibernation(): void;
    AllowHibernation(): void;
    OnReturnedFromSuspension(): IEvent;
    OnSuspended(): IEvent;
    OnEnterLowPowerMode(): IEvent;
    OnExitLowPowerMode(): IEvent;
    OnBackButtonPressed(): IEvent;
    OnForwardButtonPressed(): IEvent;
    GetServiceName(): string;
}
