import { Status } from "../../../../DataFrame";
import { ResponseResult } from "../../../FieldChangeResult";
import { ChatServiceErrorCode } from "../../ChatService";
import { IMessage, MessageHandler } from "../../IChatService";
import { IControllerChat, IControllerChatMessage } from "./IControllerChat";
export declare class ControllerChat implements IControllerChat {
    private _connection;
    private _chatSubscriptions;
    constructor();
    GetCachedMessagesAsync(): Promise<IControllerChatMessage[] | ResponseResult<ChatServiceErrorCode>>;
    SendMessageAsync(message: string): Promise<Status>;
    SubscribeToMessages<T extends IMessage>(messageHandler: MessageHandler<T>): void;
    UnsubscribeFromMessages<T extends IMessage>(messageHandler: MessageHandler<T>): void;
}
