import { Status } from "../../../../DataFrame";
import { ResponseResult } from "../../../FieldChangeResult";
import { ChatServiceErrorCode } from "../../ChatService";
import { IMessage, MessageHandler } from "../../IChatService";
import { IFamillyChat } from "./IFamillyChat";
export declare class FamillyChat implements IFamillyChat {
    private _connection;
    private _chatSubscriptions;
    constructor();
    GetCachedMessagesAsync(): Promise<ResponseResult<ChatServiceErrorCode> | IMessage[]>;
    SendMessageAsync(message: string): Promise<Status>;
    SubscribeToMessages<T extends IMessage>(messageHandler: MessageHandler<T>): void;
    UnsubscribeFromMessages<T extends IMessage>(messageHandler: MessageHandler<T>): void;
}
