import { Status } from "../../../../DataFrame";
import { ResponseResult } from "../../../FieldChangeResult";
import { ChatServiceErrorCode } from "../../ChatService";
import { IMessage, MessageHandler } from "../../IChatService";
import { ChatGptConfiguration, IGptChat } from "./IGptChat";
export declare class GptChat implements IGptChat {
    private _connection;
    private _chatSubscriptions;
    constructor();
    IsGptChatAvailableAsync(): Promise<boolean>;
    GetChatConfigurationAsync(): Promise<ChatGptConfiguration | ResponseResult<ChatServiceErrorCode>>;
    SetChatConfigurationAsync(config: ChatGptConfiguration): Promise<Status>;
    SendMessageAsync(message: string): Promise<Status>;
    SubscribeToMessages<T extends IMessage>(messageHandler: MessageHandler<T>): void;
    UnsubscribeFromMessages<T extends IMessage>(messageHandler: MessageHandler<T>): void;
}
