import { ITypedEvent } from "../../TypedEvent";
import { IEvent } from "../../Event";
import { IControllerConfigurationService } from "./IControllerConfigurationService";
import { Status } from "../../DataFrame";
export declare class ControllerConfigurationService implements IControllerConfigurationService {
    private _connection;
    private _session;
    private _localStorage;
    static readonly ServiceName: string;
    private _onEnteredConfigurationEvent;
    private _onExitedConfigurationEvent;
    private _onConfigurationTimeCheckedEvent;
    private _configurationTime;
    private _appEnteredConfigurationMode;
    private _didConfigurationChange;
    private _synchronizationTaskCompletionSource;
    GetServiceName(): string;
    constructor();
    GetControllerSystemTimeAsync(): Promise<Date | Status>;
    SetControllerSystemTimeAsync(date: Date): Promise<Status>;
    StartNtpTimeSynchronizationAsync(): Promise<Status>;
    FactoryResetAsync(func: (progress: number) => void): Promise<Status>;
    RollbackLastUpdateAsync(func: (progress: number) => void): Promise<Status>;
    RestartControllerAsync(func: (progress: number) => void): Promise<Status>;
    DidCofigurationChangeAsync(): Promise<boolean>;
    private GetLastKnownConfigurationChangeTime;
    private SaveLastConfigurationChangeTime;
    EnterConfigurationModeAsync(): Promise<void>;
    ExitConfigurationModeAsync(): Promise<void>;
    OnEnteredConfigurationEvent(): IEvent;
    OnExitedConfigurationEvent(): IEvent;
    OnConfigurationTimeCheckedEvent(): ITypedEvent<Date>;
    GetLastConfigurationChangeTimeAsync(): Promise<Date>;
    CheckIfConfigurationHasChangedAsync(): Promise<boolean>;
}
