import { ManuallyPairedDevice } from "./IDevice";
import { IManuallyPairedDevicesProtocolService } from "./IManuallyPairedDevicesProtocolService";
import { IManuallyPairedDevicesService } from "./IManuallyPairedDevicesService";
import { DeviceTaskExecutionResult } from "./TaskExecutionResult";
export declare class ManuallyPairedDevicesService implements IManuallyPairedDevicesService {
    static readonly ServiceName = "ManualDeviceService";
    private _manualDeviceProtocolServices;
    GetServiceName(): string;
    RegisterManuallyPairedDevicesProtocol(service: IManuallyPairedDevicesProtocolService): void;
    GetDevicesForManualPairingAsync(protocolGuid?: string | undefined, reloadProtocols?: boolean | undefined): Promise<ManuallyPairedDevice[]>;
    GetDevicesForManualPairingAsync(protocolGuids?: string[] | undefined, reloadProtocols?: boolean | undefined): Promise<ManuallyPairedDevice[]>;
    AddManuallyPairedDeviceAsync(device: ManuallyPairedDevice): Promise<DeviceTaskExecutionResult>;
    GetRegisteredProtocolGuids(): string[];
}
