import { DeviceTask } from "./DeviceTask";
export declare class SetTemperature extends DeviceTask {
    constructor();
    Temperature: number;
}
export declare class TurnOff extends DeviceTask {
    constructor();
}
export declare class TurnOn extends DeviceTask {
    constructor();
}
export declare class TurnOnWithTime extends DeviceTask {
    constructor();
    SwitchOffDelaySeconds: number;
}
export declare class SetLightBrightness extends DeviceTask {
    constructor();
    Brightness: number;
}
export declare class ToggleState extends DeviceTask {
    constructor();
}
export declare class SetLightColor extends DeviceTask {
    constructor();
    R: number;
    G: number;
    B: number;
}
export declare class SetLightTemperature extends DeviceTask {
    constructor();
    Temperature: number;
}
export declare class SetBlindPosition extends DeviceTask {
    constructor();
    Action: BlindActionEnum;
    Position: number;
}
export declare enum BlindActionEnum {
    Open = 0,
    Close = 1,
    Stop = 2,
    Percentage = 3
}
export declare class SetGatePositionPrecise extends DeviceTask {
    constructor();
    GateControlAction: GateActionEnum;
    Position: number;
}
export declare enum GateActionEnum {
    Open = 0,
    Close = 1,
    Stop = 2,
    Percentage = 3
}
export declare class SetBlindPositionSimple extends DeviceTask {
    constructor();
    Action: BlindActionSimpleEnum;
    Position: number;
}
export declare enum BlindActionSimpleEnum {
    Open = 0,
    Close = 1,
    Stop = 2
}
export declare class SetLightBrightnessDynamicly extends DeviceTask {
    constructor();
    Brightness: number;
}
export declare class IdentifyDevice extends DeviceTask {
    constructor();
}
export declare class SetBlindOpenCloseTime extends DeviceTask {
    constructor();
    Data: BlindOpenCloseTimeData;
}
export declare class BlindOpenCloseTimeData {
    Channel: number;
    CloseTime: number;
    OpenTime: number;
}
export declare class GetDeviceState extends DeviceTask {
    constructor();
}
export declare class SetBlindMicroventilation extends DeviceTask {
    constructor();
    Position: number;
}
export declare class ChangeGatePositionPulse extends DeviceTask {
    constructor();
}
export declare class ChangeGatewayPositionPulse extends DeviceTask {
    constructor();
}
export declare class SetFacadePosition extends DeviceTask {
    constructor();
    FacadeAction: FacadeActionEnum;
    Tilt: number;
    Position: number;
}
export declare class GetFacadeType extends DeviceTask {
    constructor();
}
export declare enum FacadeActionEnum {
    Open = 0,
    Close = 1,
    Stop = 2,
    Percentage = 3,
    Tilt = 4,
    TiltAndPercentage = 5
}
export declare class LightRGBWData {
    R: number;
    G: number;
    B: number;
    W: number;
    Brightness: number;
    Channel: number;
}
export declare class LightRGBW extends DeviceTask {
    constructor();
    Data: LightRGBWData;
}
