"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try {
            step(generator.next(value));
        }
        catch (e) {
            reject(e);
        } }
        function rejected(value) { try {
            step(generator["throw"](value));
        }
        catch (e) {
            reject(e);
        } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function () { if (t[0] & 1)
            throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f)
            throw new TypeError("Generator is already executing.");
        while (_)
            try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                    return t;
                if (y = 0, t)
                    op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0:
                    case 1:
                        t = op;
                        break;
                    case 4:
                        _.label++;
                        return { value: op[1], done: false };
                    case 5:
                        _.label++;
                        y = op[1];
                        op = [0];
                        continue;
                    case 7:
                        op = _.ops.pop();
                        _.trys.pop();
                        continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                            _ = 0;
                            continue;
                        }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                            _.label = op[1];
                            break;
                        }
                        if (op[0] === 6 && _.label < t[1]) {
                            _.label = t[1];
                            t = op;
                            break;
                        }
                        if (t && _.label < t[2]) {
                            _.label = t[2];
                            _.ops.push(op);
                            break;
                        }
                        if (t[2])
                            _.ops.pop();
                        _.trys.pop();
                        continue;
                }
                op = body.call(thisArg, _);
            }
            catch (e) {
                op = [6, e];
                y = 0;
            }
            finally {
                f = t = 0;
            }
        if (op[0] & 5)
            throw op[1];
        return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.DeviceUsedInScenes = exports.DeviceStateObject = exports.DeviceStateChangedObject = exports.DevicesService = void 0;
var TypedEvent_1 = require("../../TypedEvent");
var IDevice_1 = require("./IDevice");
var IDevicesService_1 = require("./IDevicesService");
var IDeviceState_1 = require("./IDeviceState");
var DeviceChannel_1 = require("./DeviceChannel");
var IDeviceChannel_1 = require("./IDeviceChannel");
var Api_1 = require("../../Api");
var ExalusConnectionService_1 = require("../ExalusConnectionService");
var DependencyContainer_1 = require("../../DependencyContainer");
var DataFrame_1 = require("../../DataFrame");
var Device_1 = require("./Device");
var IDeviceTask_1 = require("./IDeviceTask");
var Tasks_1 = require("./Tasks/Tasks");
var SessionService_1 = require("../Session/SessionService");
var ControllerConfigurationService_1 = require("../Controller/ControllerConfigurationService");
var TaskExecutionResult_1 = require("./TaskExecutionResult");
var ManuallyPairedDevicesService_1 = require("./ManuallyPairedDevicesService");
var IRemoteStorageService_1 = require("../IRemoteStorageService");
var RemoteStorageService_1 = require("../RemoteStorageService");
var IUser_1 = require("../Users/IUser");
var WebApiCacheService_1 = require("../WebApi/WebApiCacheService");
var ScenesService_1 = require("../Scenes/ScenesService");
var FieldChangeResult_1 = require("../FieldChangeResult");
/**
 * @type Class
 */
var DevicesService = /** @class */ (function () {
    function DevicesService() {
        var _this = this;
        this._devices = [];
        this._onDevicesTasksChangedEvent = new TypedEvent_1.TypedEvent();
        this._onDeviceFoundEvent = new TypedEvent_1.TypedEvent();
        this._onDeviceRegisteredEvent = new TypedEvent_1.TypedEvent();
        this._onDeviceRemovedEvent = new TypedEvent_1.TypedEvent();
        this._onDeviceStateChangedEvent = new TypedEvent_1.TypedEvent();
        this._connection = null;
        this._session = null;
        this._controllerConfiguration = null;
        this._synchronized = false;
        this._synchronizedDevicesStates = false;
        this._devicesChannelsStates = [];
        this._synchronizationTaskCompletionSource = null;
        this._deviceStatesSynchronizationTaskCompletionSource = null;
        this._connection = Api_1.Api.Get(ExalusConnectionService_1.ExalusConnectionService.ServiceName);
        this._session = Api_1.Api.Get(SessionService_1.SessionService.ServiceName);
        this._controllerConfiguration = Api_1.Api.Get(ControllerConfigurationService_1.ControllerConfigurationService.ServiceName);
        this._onDeviceStateChangedEvent.Subscribe(function (args) {
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.PutDeviceStateOnList(args.Device, args.State)];
                });
            });
        });
        this._synchronizationTaskCompletionSource = new Promise(function (resolve) {
            var _a;
            (_a = _this._session) === null || _a === void 0 ? void 0 : _a.OnUserLoggedInEvent().Subscribe(function (user) {
                return __awaiter(_this, void 0, void 0, function () {
                    var _a, ex_1;
                    var _b;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                _c.trys.push([0, 2, , 3]);
                                _a = this;
                                return [4 /*yield*/, this.GetPairedDevicesAsync()];
                            case 1:
                                _a._devices = _c.sent();
                                return [3 /*break*/, 3];
                            case 2:
                                ex_1 = _c.sent();
                                (_b = DependencyContainer_1.DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Error(DevicesService.ServiceName, "Failed to get paired devices: " + ex_1);
                                return [3 /*break*/, 3];
                            case 3:
                                this._synchronized = true;
                                resolve();
                                return [2 /*return*/];
                        }
                    });
                });
            });
        });
        this._deviceStatesSynchronizationTaskCompletionSource = new Promise(function (resolve) {
            var _a;
            (_a = _this._session) === null || _a === void 0 ? void 0 : _a.OnUserLoggedInEvent().Subscribe(function (user) {
                return __awaiter(_this, void 0, void 0, function () {
                    var ex_2;
                    var _a;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _b.trys.push([0, 3, , 4]);
                                return [4 /*yield*/, this.WaitForSynchronizationAsync()];
                            case 1:
                                _b.sent();
                                return [4 /*yield*/, this.SyncDevicesStatesAsync()];
                            case 2:
                                _b.sent();
                                return [3 /*break*/, 4];
                            case 3:
                                ex_2 = _b.sent();
                                (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Error(DevicesService.ServiceName, "Failed to sync devices states: " + ex_2);
                                return [3 /*break*/, 4];
                            case 4:
                                this._synchronizedDevicesStates = true;
                                resolve();
                                return [2 /*return*/];
                        }
                    });
                });
            });
        });
        this._connection.OnDataReceivedEvent().Subscribe(function (frame) {
            if (frame.Resource === "/info/devices/tasks") {
                _this.ParseDeviceTaskInfo(frame.Data);
            }
            else if (frame.Resource === "/devices/blinds/times") {
            }
            else if (frame.Resource === "/info/devices/device/found") {
                var foundDevices = _this.MapApiDevices(frame.Data);
                foundDevices.forEach(function (device) {
                    var _a;
                    if (device.DeviceType == IDevice_1.DeviceType.Scene)
                        return;
                    (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug(DevicesService.ServiceName, "Found device: " + device.Name + " guid: " + device.Guid);
                    _this._onDeviceFoundEvent.Invoke(device);
                });
            }
            else if (frame.Resource === "/info/devices/device/state/changed") {
                var state_1 = frame.Data;
                var devices = _this._devices.filter(function (a) { return a.Guid == state_1.DeviceGuid; });
                if (devices.length > 0) {
                    var device_1 = devices[0];
                    var st = _this.MapApiDeviceStateToDeviceState(device_1, state_1);
                    if (st != null) {
                        _this._onDeviceStateChangedEvent
                            .Invoke({ Device: device_1, State: st });
                        if (st.TypeAsEnum == IDevice_1.DeviceResponseType.SignalStrength) {
                            device_1.Channels.forEach(function (channel) {
                                /// object copy { ...state }
                                var newState = new IDeviceState_1.SignalStrenghtDeviceState(__assign({}, state_1));
                                newState.Data.Channel = channel.Number;
                                _this._onDeviceStateChangedEvent
                                    .Invoke({ Device: device_1, State: newState });
                            });
                        }
                        else if (st.TypeAsEnum == IDevice_1.DeviceResponseType.BatteryState) {
                            device_1.Channels.forEach(function (channel) {
                                var newState = new IDeviceState_1.BatteryDeviceState(__assign({}, state_1));
                                newState.Data.Channel = channel.Number;
                                _this._onDeviceStateChangedEvent
                                    .Invoke({ Device: device_1, State: newState });
                            });
                        }
                    }
                }
            }
            else if (frame.Resource === "/info/devices/device/registered") {
                Api_1.Api.Get(WebApiCacheService_1.WebApiCacheService.ServiceName).ClearCache();
                var registeredDevices = _this.MapApiDevices(frame.Data);
                registeredDevices.forEach(function (device) {
                    var _a;
                    (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug(DevicesService.ServiceName, "Registered device: " + device.Name + " guid: " + device.Guid);
                    _this._devices.push(device);
                    _this._onDeviceRegisteredEvent.Invoke(device);
                });
            }
            else if (frame.Resource === "/info/devices/device/removed") {
                Api_1.Api.Get(WebApiCacheService_1.WebApiCacheService.ServiceName).ClearCache();
                var removedDevices = _this.MapApiDevices(frame.Data);
                removedDevices.forEach(function (device) {
                    var _a;
                    (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug(DevicesService.ServiceName, "Removed device: " + device.Name + " guid: " + device.Guid);
                    _this._devices = _this._devices.filter(function (a) { return a.Guid != device.Guid; });
                    _this._onDeviceRemovedEvent.Invoke(device);
                });
            }
        });
    }
    DevicesService.prototype.CheckIfDeviceUsedInScenesAsync = function (dev) {
        var _a, _b, _c, _d, _e, _f;
        return __awaiter(this, void 0, Promise, function () {
            var device, result_1, resp, seqList, result_2, error_1;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        _g.trys.push([0, 3, , 4]);
                        device = void 0;
                        if (typeof dev == 'string') {
                            result_1 = this.GetDevice(dev);
                            if (result_1 != null)
                                device = result_1;
                            else {
                                (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Error("Cannot check if device is used in scenes! Device with given guid not exists");
                                return [2 /*return*/, DataFrame_1.Status.ResourceDoesNotExists];
                            }
                        }
                        else {
                            device = dev;
                        }
                        return [4 /*yield*/, ((_b = this._connection) === null || _b === void 0 ? void 0 : _b.SendAndWaitForResponseAsync(new DeviceIsUsedInScenesRequest(device.Guid), 20000, false))];
                    case 1:
                        resp = _g.sent();
                        if (resp == null || resp.Status == null) {
                            (_c = DependencyContainer_1.DependencyContainer.Log) === null || _c === void 0 ? void 0 : _c.Error("Cannot check if device is used in scenes! Response or status is null!");
                            return [2 /*return*/, DataFrame_1.Status.FatalError];
                        }
                        if (resp.Status != DataFrame_1.Status.OK)
                            return [2 /*return*/, resp.Status];
                        if (resp.Data == null) {
                            (_d = DependencyContainer_1.DependencyContainer.Log) === null || _d === void 0 ? void 0 : _d.Error("Cannot check if device is used in scenes! No data!");
                            return [2 /*return*/, DataFrame_1.Status.FatalError];
                        }
                        return [4 /*yield*/, Api_1.Api.Get(ScenesService_1.ScenesService.ServiceName).GetSequencesListAsync()];
                    case 2:
                        seqList = _g.sent();
                        if (seqList instanceof FieldChangeResult_1.ResponseResult) {
                            (_e = DependencyContainer_1.DependencyContainer.Log) === null || _e === void 0 ? void 0 : _e.Error("Cannot check if device is used in scenes! Cannot get sequence list, ScenesServiceErrorCode: " + seqList.Type);
                            return [2 /*return*/, DataFrame_1.Status.Error];
                        }
                        result_2 = new DeviceUsedInScenes();
                        result_2.DeviceGuid = device.Guid;
                        resp.Data.ConditionsAsCondition.forEach(function (cGuid) {
                            var con = seqList.find(function (s) { return s.Guid == cGuid; });
                            if (con)
                                result_2.ConditionsAsCondition.push(con);
                        });
                        resp.Data.ConditionsAsTask.forEach(function (tGuid) {
                            var con = seqList.find(function (s) { return s.Guid == tGuid; });
                            if (con)
                                result_2.ConditionsAsCondition.push(con);
                        });
                        return [2 /*return*/, result_2];
                    case 3:
                        error_1 = _g.sent();
                        (_f = DependencyContainer_1.DependencyContainer.Log) === null || _f === void 0 ? void 0 : _f.Error("Cannot check if device is used in scenes! " + error_1);
                        return [2 /*return*/, DataFrame_1.Status.FatalError];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.CanEditDevicesInfo = function () {
        var _a, _b;
        if (this._session === null || this._session === undefined)
            return false;
        if (this._session.User === null || this._session.User === undefined)
            return false;
        return ((_b = (_a = this._session) === null || _a === void 0 ? void 0 : _a.User) === null || _b === void 0 ? void 0 : _b.AccessLevel) >= IUser_1.AccessLevel.Admin;
    };
    DevicesService.prototype.CanAddAndRemoveAndConfigureDevices = function () {
        var _a, _b;
        if (this._session === null || this._session === undefined)
            return false;
        if (this._session.User === null || this._session.User === undefined)
            return false;
        return ((_b = (_a = this._session) === null || _a === void 0 ? void 0 : _a.User) === null || _b === void 0 ? void 0 : _b.AccessLevel) >= IUser_1.AccessLevel.Installator;
    };
    DevicesService.prototype.GetDeviceChannelByChannelId = function (channelId) {
        return this._devices.firstOrDefault(function (device) { return device.Channels.any(function (channel) { return channel.ChannelId == channelId; }); })
            .Channels.firstOrDefault(function (channel) { return channel.ChannelId == channelId; });
    };
    DevicesService.prototype.EnableFastStatesSyncAsync = function () {
        return __awaiter(this, void 0, Promise, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        res = Api_1.Api.Get(RemoteStorageService_1.RemoteStorageService.ServiceName).SaveAsync("FastDevicesSync", false, true);
                        return [4 /*yield*/, Api_1.Api.Get(ControllerConfigurationService_1.ControllerConfigurationService.ServiceName).ExitConfigurationModeAsync()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    DevicesService.prototype.DisableFastStatesSyncAsync = function () {
        return __awaiter(this, void 0, Promise, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        res = Api_1.Api.Get(RemoteStorageService_1.RemoteStorageService.ServiceName).SaveAsync("FastDevicesSync", false, false);
                        return [4 /*yield*/, Api_1.Api.Get(ControllerConfigurationService_1.ControllerConfigurationService.ServiceName).ExitConfigurationModeAsync()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    DevicesService.prototype.IsFastStatesSyncEnabledAsync = function () {
        return __awaiter(this, void 0, Promise, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Api_1.Api.Get(RemoteStorageService_1.RemoteStorageService.ServiceName).ReadAsync("FastDevicesSync", false, false)];
                    case 1:
                        res = _a.sent();
                        if (res instanceof IRemoteStorageService_1.RemoteStorageDataEntry) {
                            return [2 /*return*/, res.Data];
                        }
                        //Controller returns ResourceDoesNotExists if fastSync option was never enabled (no option in DB - default slow sync)
                        if (res == DataFrame_1.Status.ResourceDoesNotExists)
                            return [2 /*return*/, false];
                        return [2 /*return*/, res];
                }
            });
        });
    };
    DevicesService.prototype.GetDevicesForManualPairingAsync = function (protocol) {
        return __awaiter(this, void 0, Promise, function () {
            var service, regGuid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        service = Api_1.Api.Get(ManuallyPairedDevicesService_1.ManuallyPairedDevicesService.ServiceName);
                        regGuid = new RegExp("^[{]?[0-9a-fA-F]{8}-([0-9a-fA-F]{4}-){3}[0-9a-fA-F]{12}[}]?$");
                        if (!Array.isArray(protocol))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, service.GetDevicesForManualPairingAsync(protocol)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        if (!regGuid.test(protocol))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, service.GetDevicesForManualPairingAsync(protocol)];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4: return [4 /*yield*/, service.GetDevicesForManualPairingAsync()];
                    case 5: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    DevicesService.prototype.AddManuallyPairedDevice = function (device) {
        return __awaiter(this, void 0, Promise, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Api_1.Api.Get(ManuallyPairedDevicesService_1.ManuallyPairedDevicesService.ServiceName).AddManuallyPairedDeviceAsync(device)];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, Api_1.Api.Get(ControllerConfigurationService_1.ControllerConfigurationService.ServiceName).ExitConfigurationModeAsync()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    DevicesService.prototype.GetDeviceChannelStates = function (device, channel) {
        var _a, _b;
        return (_b = (_a = this._devicesChannelsStates.firstOrDefault(function (a) { return a.DeviceGuid == device.Guid; })) === null || _a === void 0 ? void 0 : _a.ChannelsStates.filter(function (a) { return a.Channel == channel; })) !== null && _b !== void 0 ? _b : [];
    };
    DevicesService.prototype.GetDeviceStates = function (device) {
        var _a, _b;
        return (_b = (_a = this._devicesChannelsStates.firstOrDefault(function (a) { return a.DeviceGuid == device.Guid; })) === null || _a === void 0 ? void 0 : _a.ChannelsStates) !== null && _b !== void 0 ? _b : [];
    };
    DevicesService.prototype.PutDeviceStateOnList = function (device, state) {
        var deviceStatesOnList = this._devicesChannelsStates.firstOrDefault(function (a) { return a.DeviceGuid == device.Guid; });
        if (deviceStatesOnList == null) {
            var s = new DeviceChannelStates();
            s.Channel = state.Data.Channel;
            s.States = [state];
            deviceStatesOnList = { DeviceGuid: device.Guid, ChannelsStates: [s] };
            this._devicesChannelsStates.push(deviceStatesOnList);
        }
        else {
            var channel = deviceStatesOnList.ChannelsStates.firstOrDefault(function (a) { return a.Channel == state.Data.Channel; });
            if (channel == null) {
                channel = new DeviceChannelStates();
                channel.Channel = state.Data.Channel;
                channel.States = [state];
                deviceStatesOnList.ChannelsStates.push(channel);
            }
            else {
                var currentState = channel.States.firstOrDefault(function (a) { return a.TypeAsEnum == state.TypeAsEnum; });
                if (currentState != null)
                    channel.States = channel.States.where(function (a) { return a.TypeAsEnum != state.TypeAsEnum; }).toArray();
                channel.States.push(state);
            }
        }
    };
    DevicesService.prototype.WaitForSynchronizationAsync = function () {
        return this._synchronizationTaskCompletionSource;
    };
    DevicesService.prototype.WaitForDevicesStatesSynchronizationAsync = function () {
        return this._deviceStatesSynchronizationTaskCompletionSource;
    };
    DevicesService.prototype.GetCurrentlyRunningTaksAsync = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetRunningDevicesTasksRequest(), 15000, false))];
                    case 1:
                        result = _b.sent();
                        if ((result === null || result === void 0 ? void 0 : result.Status) == DataFrame_1.Status.OK && result.Data != null) {
                            this.ParseDeviceTaskInfo(result.Data);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.ParseDeviceTaskInfo = function (tasks) {
        var devicesTasks = [];
        tasks.forEach(function (taskChannelPair) {
            var pair = taskChannelPair.split(";");
            var task = new IDevice_1.DeviceTasksInfo();
            task.DeviceGuid = pair[0];
            task.Channel = Number(pair[1]);
            task.Status = IDeviceChannel_1.TaskExecution.ExecutingTasks;
            devicesTasks.push(task);
        });
        this._onDevicesTasksChangedEvent.Invoke(devicesTasks);
    };
    DevicesService.prototype.MapApiDeviceStateToDeviceState = function (device, state) {
        var _a;
        var st = state.state;
        switch (state.DataType) {
            case "ChannelOnOff":
                return new IDeviceState_1.ChannelOnOffDeviceState(state);
            case "DoorBell":
                return new IDeviceState_1.DoorBellDeviceState(state);
            case "ReedPosition":
                return new IDeviceState_1.ReedStateDeviceState(state);
            case "BlindPosition":
                return new IDeviceState_1.BlindPositionDeviceState(state);
            case "ButtonState":
                return new IDeviceState_1.RemoteButtonDeviceState(state);
            case "LightColor":
                return new IDeviceState_1.LightColorDeviceState(state);
            case "LightTemperature":
                return new IDeviceState_1.LightWarmthDeviceState(state);
            case "LightBrightness":
                return new IDeviceState_1.LightBrightnessDeviceState(state);
            case "TemperatureSensor":
            case "TemperatureState":
            case "MeasuredTemperature":
                return new IDeviceState_1.MeasuredTemperatureDeviceState(state);
            case "BatteryState":
                return new IDeviceState_1.BatteryDeviceState(state);
            case "MeasuredBrightness":
            case "DeviceBrightnessState":
                return new IDeviceState_1.MeasuredBrightnessDeviceState(state);
            case "EnergyMeasuredPower":
                break;
            case "EnergyMeasuredCurrent":
                break;
            case "EnergyMeasuredVoltage":
                break;
            case "IEnergy":
            case "Energy":
                return new IDeviceState_1.MeasuredEnergyDeviceState(state);
            case "DistanceSensor":
                return new IDeviceState_1.MeasuredDistanceDeviceState(state);
            case "MovementSensor":
                return new IDeviceState_1.MovementSensorDeviceState(state);
            case "BlindsControlButton":
                return new IDeviceState_1.BlindRemoteButtonDeviceState(state);
            case "FacadeControlButton":
                return new IDeviceState_1.FacadeRemoteButtonDeviceState(state);
            case "SignalStrength":
                return new IDeviceState_1.SignalStrenghtDeviceState(state);
            case "GatePosition":
                return new IDeviceState_1.GatePositionDeviceState(state);
            case "GatewayPosition":
                return new IDeviceState_1.GatewayPositionDeviceState(state);
            case "IBlindCalibrationStatus":
            case "BlindCalibration":
                return new IDeviceState_1.BlindCalibrationDeviceState(state);
            case "HumiditySensor":
            case "HumidityState":
                return new IDeviceState_1.HumiditySensorDeviceState(state);
            case "VibrationSensor":
                return new IDeviceState_1.VibrationSensorDeviceState(state);
            case "DigitalInputSensor":
                return new IDeviceState_1.BinarySensorStateDeviceState(state);
            case "ConfigurationState":
                return new IDeviceState_1.ConfigurationDeviceState(state);
            case "BlindOpenCloseTime":
            case "IBlindOpenCloseTime":
                return new IDeviceState_1.BlindOpenCloseTimeDeviceState(state);
            case "IOvercurrentProtection":
            case "OvercurrentProtection":
                return new IDeviceState_1.OvercurrentProtectionDeviceState(state);
            case "IOvercurrentProtectionThreshold":
            case "OvercurrentProtectionThreshold":
                return new IDeviceState_1.OvercurrentProtectionThresholdDeviceState(state);
            case "FacadePosition":
            case "FacadeState":
                return new IDeviceState_1.FacadePositionDeviceState(state);
            case "FacadeTypeState":
                return new IDeviceState_1.FacadeTypeDeviceState(state);
            case "CurrentWindThreshold":
                return new IDeviceState_1.CurrentWindThresholdDeviceState(state);
            case "CurrentLightThreshold":
                return new IDeviceState_1.CurrentLightThresholdDeviceState(state);
            case "WindSpeed":
                return new IDeviceState_1.WindSpeedDeviceState(state);
            case "FloodSensor":
                return new IDeviceState_1.FloodSensorDeviceState(state);
            case "PressureState":
                return new IDeviceState_1.PressureSensorDeviceState(state);
            case "ITamperProtection":
            case "TamperProtection":
                return new IDeviceState_1.TamperProtectionDeviceState(state);
            case "ILightRGBW":
            case "LightRGBW":
                return new IDeviceState_1.LightRGBWDeviceState(state);
            case "OnlineCamera":
            case "IOnlineCamera":
                return new IDeviceState_1.OnlineCameraState(state);
            default:
                (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug(DevicesService.ServiceName, "Not supported device state " + state.DataType);
                break;
        }
        return null;
    };
    DevicesService.prototype.GetServiceName = function () {
        return DevicesService.ServiceName;
    };
    DevicesService.prototype.SyncDevicesStatesAsync = function () {
        var _a, _b;
        return __awaiter(this, void 0, Promise, function () {
            var result, syncStatesRequest, result_3;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetDevicesStatesRequest(), 15000, false))];
                    case 1:
                        result = _c.sent();
                        return [4 /*yield*/, this.IsFastStatesSyncEnabledAsync()];
                    case 2:
                        if (!_c.sent())
                            return [3 /*break*/, 3];
                        return [2 /*return*/, (result === null || result === void 0 ? void 0 : result.Status) == DataFrame_1.Status.OK];
                    case 3:
                        syncStatesRequest = new SyncDevicesStatesRequest();
                        syncStatesRequest.Data = true;
                        return [4 /*yield*/, ((_b = this._connection) === null || _b === void 0 ? void 0 : _b.SendAndWaitForResponseAsync(syncStatesRequest, 35000, false))];
                    case 4:
                        result_3 = _c.sent();
                        return [2 /*return*/, (result_3 === null || result_3 === void 0 ? void 0 : result_3.Status) == DataFrame_1.Status.OK];
                }
            });
        });
    };
    DevicesService.prototype.OnDevicesTasksExecutionChangeEvent = function () {
        return this._onDevicesTasksChangedEvent;
    };
    DevicesService.prototype.OnDeviceStateChangedEvent = function () {
        return this._onDeviceStateChangedEvent;
    };
    DevicesService.prototype.OnDeviceRegisteredEvent = function () {
        return this._onDeviceRegisteredEvent;
    };
    DevicesService.prototype.OnDeviceRemovedEvent = function () {
        return this._onDeviceRemovedEvent;
    };
    DevicesService.prototype.OnDeviceFoundEvent = function () {
        return this._onDeviceFoundEvent;
    };
    DevicesService.prototype.MapApiDevices = function (devicesObjects) {
        var devices = [];
        if (devicesObjects == null)
            return [];
        devicesObjects.forEach(function (element) {
            var _a, _b, _c, _d;
            var device = new Device_1.Device();
            device.Guid = element.Guid;
            device.Name = element.DeviceName;
            device.ChannelsAmount = element.ChannelsNumber;
            device.DeviceType = element.DeviceType;
            device.CommunicationWay = element.CommunicationWay;
            device.DeviceState = element.DeviceState;
            device.IsEnabled = element.IsEnabled;
            device.IsVirtual = element.IsVirtual;
            device.SerialNumber = element.DeviceSerialNumber;
            device.ManufacturerGuid = element.ManufacturerGuid;
            device.ModelGuid = element.DeviceModelGuid;
            device.Model = element.DeviceModel;
            device.Name = element.DeviceName;
            device.ProtocolGuid = element.ProtocolGuid;
            try {
                (_a = element.AvailableTasks) === null || _a === void 0 ? void 0 : _a.forEach(function (task) {
                    var typeInfo = new IDevice_1.DeviceTaskTypeInfo();
                    if (device.CommunicationWay == IDevice_1.CommunicationWay.OneWay) {
                        switch (task) {
                            case "IBlindPosition":
                                typeInfo.InterfaceType = "IBlindPositionSimple";
                                break;
                        }
                    }
                    else
                        switch (task) {
                            case "IGatePosition":
                                typeInfo.InterfaceType = "IGatePulse";
                                break;
                            case "IGatewayPosition":
                                typeInfo.InterfaceType = "IGatewayPulse";
                                break;
                            default:
                                typeInfo.InterfaceType = task;
                                break;
                        }
                    device.AvailableTaskTypes.push(typeInfo);
                });
                (_b = element.AvailableResponses) === null || _b === void 0 ? void 0 : _b.forEach(function (response) {
                    var typeInfo = new IDevice_1.DeviceResponseTypeInfo();
                    typeInfo.InterfaceType = response;
                    device.AvailableResponseTypes.push(typeInfo);
                });
                (_c = element.ChannelsConfiguration) === null || _c === void 0 ? void 0 : _c.forEach(function (configuration) {
                    var _a, _b, _c;
                    try {
                        var ch = new DeviceChannel_1.DeviceChannel();
                        ch.Number = configuration.Channel;
                        device.Channels.push(ch);
                        ch.SetDevice(device);
                        ch.Name = configuration.ChannelName;
                        ch.ChannelGroups = configuration.GroupsGuids;
                        ch.IconName = configuration.IconName;
                        ch.IsHidden = configuration.Hidden;
                        ch.Configurations = configuration.Configurations;
                        ch.CustomDataAndRolesSupported = configuration.CustomData !== undefined && configuration.CustomData !== null;
                        if (configuration.CustomData !== undefined && configuration.CustomData !== null)
                            ch.CustomData = configuration.CustomData;
                        if (configuration.Roles !== undefined && configuration.Roles !== null)
                            ch.Roles = configuration.Roles;
                        (_a = configuration.AvailableResponses) === null || _a === void 0 ? void 0 : _a.forEach(function (response) {
                            var typeInfo = new IDevice_1.DeviceResponseTypeInfo();
                            typeInfo.InterfaceType = response;
                            ch.AvailableResponseTypes.push(typeInfo);
                        });
                        (_b = configuration.AvailableTasks) === null || _b === void 0 ? void 0 : _b.forEach(function (task) {
                            var typeInfo = new IDevice_1.DeviceTaskTypeInfo();
                            typeInfo.InterfaceType = task;
                            ch.AvailableTaskTypes.push(typeInfo);
                        });
                    }
                    catch (ex) {
                        (_c = DependencyContainer_1.DependencyContainer.Log) === null || _c === void 0 ? void 0 : _c.Error(ex);
                    }
                });
            }
            catch (ex) {
                (_d = DependencyContainer_1.DependencyContainer.Log) === null || _d === void 0 ? void 0 : _d.Error(ex);
            }
            devices.push(device);
        });
        return devices;
    };
    DevicesService.prototype.GetPairedDevicesAsync = function (withScenes) {
        var _a, _b, _c;
        if (withScenes === void 0) {
            withScenes = false;
        }
        return __awaiter(this, void 0, Promise, function () {
            var _d, result;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _d = this._synchronized;
                        if (!_d)
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, ((_a = this._controllerConfiguration) === null || _a === void 0 ? void 0 : _a.DidCofigurationChangeAsync())];
                    case 1:
                        _d = !(_e.sent());
                        _e.label = 2;
                    case 2:
                        if (_d)
                            return [2 /*return*/, Promise.resolve(this._devices)];
                        return [4 /*yield*/, ((_b = this._connection) === null || _b === void 0 ? void 0 : _b.SendAndWaitForResponseAsync(new GetDevicesListRequest(), 15000, true))];
                    case 3:
                        result = _e.sent();
                        if (result == null || result === undefined)
                            return [2 /*return*/, []];
                        if (result.Status == DataFrame_1.Status.OK && result.Data != null) {
                            if (withScenes)
                                return [2 /*return*/, this.MapApiDevices(result.Data)];
                            else
                                return [2 /*return*/, this.MapApiDevices(result.Data.filter(function (d) { return d.DeviceType != IDevice_1.DeviceType.Scene; }))];
                        }
                        else {
                            (_c = DependencyContainer_1.DependencyContainer.Log) === null || _c === void 0 ? void 0 : _c.Error(DevicesService.ServiceName, "Failed to get devices. " + result.Status + " " + result.Data);
                            return [2 /*return*/, []];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.GetDevicesAsync = function (withScenes) {
        if (withScenes === void 0) {
            withScenes = false;
        }
        return __awaiter(this, void 0, Promise, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.WaitForSynchronizationAsync()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, this.GetPairedDevicesAsync(withScenes)];
                }
            });
        });
    };
    DevicesService.prototype.GetFoundDevicesAsync = function () {
        var _a, _b;
        return __awaiter(this, void 0, Promise, function () {
            var result;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetFoundDevicesRequest(), 15000, false))];
                    case 1:
                        result = _c.sent();
                        if (result == null)
                            return [2 /*return*/, []];
                        if (result.Status == DataFrame_1.Status.OK && result.Data != null)
                            return [2 /*return*/, this.MapApiDevices(result.Data).where(function (a) { return a.DeviceType !== IDevice_1.DeviceType.Scene; }).toArray()];
                        else {
                            (_b = DependencyContainer_1.DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Error(DevicesService.ServiceName, "Failed to get found devices. " + result.Status + " " + result.Data);
                            return [2 /*return*/, []];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.GetDevice = function (guid) {
        return this._devices.find(function (a) { return a.Guid === guid; });
    };
    DevicesService.prototype.FindDevicesAsync = function () {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        Api_1.Api.Get(WebApiCacheService_1.WebApiCacheService.ServiceName).ClearCache();
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new SearchForDevicesRequest(), 35000, false))];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.StopSearchingForDevices = function () {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new StopSearchingForDevicesRequest(), 20000, false))];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.RegisterDeviceAsync = function (device) {
        var _a, _b;
        return __awaiter(this, void 0, Promise, function () {
            var req, res, ex_3;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 2, , 3]);
                        req = new DevicePairRequest();
                        req.Data = device.Guid;
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(req, 20000, false))];
                    case 1:
                        res = _c.sent();
                        Api_1.Api.Get(WebApiCacheService_1.WebApiCacheService.ServiceName).ClearCache();
                        Api_1.Api.Get(ControllerConfigurationService_1.ControllerConfigurationService.ServiceName).ExitConfigurationModeAsync();
                        if ((res === null || res === void 0 ? void 0 : res.Status) == DataFrame_1.Status.OK) {
                            if (!(this._devices.any(function (d) { return d.Guid == device.Guid; })))
                                this._devices.push(device);
                            this._onDeviceRegisteredEvent.Invoke(device);
                            return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Executed];
                        }
                        else
                            return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Failed];
                        return [3 /*break*/, 3];
                    case 2:
                        ex_3 = _c.sent();
                        (_b = DependencyContainer_1.DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Error(DevicesService.ServiceName, "Failed to paired devices: " + ex_3);
                        return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.ControllerResponseTimeout];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.RemoveDeviceAsync = function (device, force) {
        var _a;
        if (force === void 0) {
            force = false;
        }
        return __awaiter(this, void 0, Promise, function () {
            var req, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        req = new DeviceUnpairRequest();
                        if (force)
                            req = new ForceDeviceUnpairRequest();
                        req.Data = device.Guid;
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(req, 35000, false))];
                    case 1:
                        res = _b.sent();
                        Api_1.Api.Get(WebApiCacheService_1.WebApiCacheService.ServiceName).ClearCache();
                        Api_1.Api.Get(ControllerConfigurationService_1.ControllerConfigurationService.ServiceName).ExitConfigurationModeAsync();
                        if ((res === null || res === void 0 ? void 0 : res.Status) == DataFrame_1.Status.OK) {
                            this._devices = this._devices.where(function (a) { return a.Guid != device.Guid; }).toArray();
                            this._onDeviceRemovedEvent.Invoke(device);
                            return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Executed];
                        }
                        else
                            return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Failed];
                        return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.MapDeviceTaskToDeviceTaskInfo = function (device, task) {
        var t = new DeviceTaskInfo();
        var tsk = task;
        switch (tsk.FeatureType) {
            case IDeviceTask_1.DeviceControlFeature.SetTemperature:
                t.Data = tsk.Temperature;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightBrightness:
                t.Data = tsk.Brightness;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightColor:
                t = new LightColorTaskInfo();
                var ts = tsk;
                t.R = ts.R;
                t.G = ts.G;
                t.B = ts.B;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightTemperature:
                t.Data = tsk.Temperature;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetGatePositionPrecise:
                switch (tsk.GateControlAction) {
                    case Tasks_1.GateActionEnum.Open:
                        t.Data = 101;
                        break;
                    case Tasks_1.GateActionEnum.Close:
                        t.Data = 102;
                        break;
                    case Tasks_1.GateActionEnum.Stop:
                        t.Data = 103;
                        break;
                    case Tasks_1.GateActionEnum.Percentage:
                        t.Data = tsk.Position;
                        break;
                }
                break;
            case IDeviceTask_1.DeviceControlFeature.SetBlindPosition:
                switch (tsk.Action) {
                    case Tasks_1.BlindActionEnum.Open:
                        t.Data = 101;
                        break;
                    case Tasks_1.BlindActionEnum.Close:
                        t.Data = 102;
                        break;
                    case Tasks_1.BlindActionEnum.Stop:
                        t.Data = 103;
                        break;
                    case Tasks_1.BlindActionEnum.Percentage:
                        t.Data = tsk.Position;
                        break;
                }
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightBrightnessDynamicly:
                t.Data = tsk.Brightness;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetBlindOpenCloseTime:
                t.Data = tsk.Data;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetBlindMicroventilation:
                t.Data = tsk.Position;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetFacadePositionAndTilt:
                t = new FacadePositionTaskInfo();
                var fp = tsk;
                t.FacadeAction = fp.FacadeAction;
                t.Tilt = fp.Tilt;
                t.Position = fp.Position;
                break;
            case IDeviceTask_1.DeviceControlFeature.LightRGBW:
                t.Data = tsk.Data;
                break;
            case IDeviceTask_1.DeviceControlFeature.GatePulse:
            case IDeviceTask_1.DeviceControlFeature.GatewayPulse:
                t.Data = 0;
                break;
            case IDeviceTask_1.DeviceControlFeature.TurnOnWithTimeout:
                t.Data = tsk.SwitchOffDelaySeconds;
                break;
        }
        t.Channel = tsk.Channel;
        t.DeviceGuid = device.Guid;
        t.ControlFeature = tsk.FeatureType;
        return t;
    };
    DevicesService.prototype.ExecuteDeviceTaskAsync = function (device, task) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        return __awaiter(this, void 0, Promise, function () {
            var t, req, result, ex_4, ex_5;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        _j.trys.push([0, 5, , 6]);
                        (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug(DevicesService.ServiceName, "Preparing device task execution, device: " + device.Guid + " task: " + task.TaskType + " channel: " + task.Channel);
                        t = this.MapDeviceTaskToDeviceTaskInfo(device, task);
                        _j.label = 1;
                    case 1:
                        _j.trys.push([1, 3, , 4]);
                        req = new ExecuteDeviceTaskRequest(t);
                        (_b = DependencyContainer_1.DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Debug(DevicesService.ServiceName, "Sending device task for execution, device: " + t.DeviceGuid + " task: " + t.ControlFeature + " channel: " + t.Channel + " request: " + JSON.stringify(req));
                        return [4 /*yield*/, ((_c = this._connection) === null || _c === void 0 ? void 0 : _c.SendAndWaitForResponseAsync(req, 15000, false))];
                    case 2:
                        result = _j.sent();
                        switch (result === null || result === void 0 ? void 0 : result.Status) {
                            case DataFrame_1.Status.OK:
                                return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Executed];
                            case DataFrame_1.Status.FatalError:
                                (_d = DependencyContainer_1.DependencyContainer.Log) === null || _d === void 0 ? void 0 : _d.Error(DevicesService.ServiceName, "Fatal error occured when tried to execute task on device. Error code: " + result.Data);
                                return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Failed];
                            case DataFrame_1.Status.WrongData:
                                switch (result.Data) {
                                    case "DeviceNotFound":
                                        return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.DeviceNotFound];
                                }
                                break;
                            case DataFrame_1.Status.Error:
                                switch (result.Data) {
                                    case "DeviceResponseTimeout":
                                        return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.DeviceResponseTimeout];
                                }
                                (_e = DependencyContainer_1.DependencyContainer.Log) === null || _e === void 0 ? void 0 : _e.Error(DevicesService.ServiceName, "Unknown error occured when trying to execute task on device. Error code: " + result.Data);
                                return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Failed];
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        ex_4 = _j.sent();
                        if (ex_4.message.includes("timeout")) {
                            (_f = DependencyContainer_1.DependencyContainer.Log) === null || _f === void 0 ? void 0 : _f.Error(DevicesService.ServiceName, "Failed to get controller response in time.\n" + ex_4);
                            return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.ControllerResponseTimeout];
                        }
                        else {
                            (_g = DependencyContainer_1.DependencyContainer.Log) === null || _g === void 0 ? void 0 : _g.Error(DevicesService.ServiceName, "Unknown error occured when tried to execute task on device.\n" + ex_4);
                            return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Failed];
                        }
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Unknown];
                    case 5:
                        ex_5 = _j.sent();
                        (_h = DependencyContainer_1.DependencyContainer.Log) === null || _h === void 0 ? void 0 : _h.Error(DevicesService.ServiceName, "Unknown error occured when tried to execute task on device.\n" + ex_5);
                        return [2 /*return*/, TaskExecutionResult_1.DeviceTaskExecutionResult.Failed];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    DevicesService.prototype.ExecuteDevicesTasksAsync = function (tasks) {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, Promise, function () {
            var results, tasksPair, devices, position, _i, tasks_1, _e, device, task, tmp, req, result_4, responsePosition_1, ex_6, _f, tasks_2, _g, device, task, info, _h, tasks_3, _j, device, task, info;
            return __generator(this, function (_k) {
                switch (_k.label) {
                    case 0:
                        results = [];
                        tasksPair = [];
                        devices = [];
                        position = 0;
                        for (_i = 0, tasks_1 = tasks; _i < tasks_1.length; _i++) {
                            _e = tasks_1[_i], device = _e[0], task = _e[1];
                            tmp = this.MapDeviceTaskToDeviceTaskInfo(device, task);
                            tmp.SequnceExecutionOrder = position;
                            position++;
                            tasksPair.push(tmp);
                        }
                        req = new ExecuteDevicesTasksRequest(tasksPair);
                        _k.label = 1;
                    case 1:
                        _k.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(req, 120000, false))];
                    case 2:
                        result_4 = _k.sent();
                        responsePosition_1 = -1;
                        (_b = result_4 === null || result_4 === void 0 ? void 0 : result_4.Data) === null || _b === void 0 ? void 0 : _b.forEach(function (element) {
                            var _a, _b;
                            responsePosition_1++;
                            var res = TaskExecutionResult_1.DeviceTaskExecutionResult.Unknown;
                            switch (element.Status) {
                                case DataFrame_1.Status.OK:
                                    return TaskExecutionResult_1.DeviceTaskExecutionResult.Executed;
                                case DataFrame_1.Status.FatalError:
                                    (_a = DependencyContainer_1.DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Error(DevicesService.ServiceName, "Fatal error occured when tried to execute task on device. Error code: " + element.Data);
                                    res = TaskExecutionResult_1.DeviceTaskExecutionResult.Failed;
                                    break;
                                case DataFrame_1.Status.WrongData:
                                    switch (element.Data) {
                                        case "DeviceNotFound":
                                            res = TaskExecutionResult_1.DeviceTaskExecutionResult.DeviceNotFound;
                                            break;
                                    }
                                    break;
                                case DataFrame_1.Status.Error:
                                    switch (element.Data) {
                                        case "DeviceResponseTimeout":
                                            res = TaskExecutionResult_1.DeviceTaskExecutionResult.DeviceResponseTimeout;
                                            break;
                                        default:
                                            (_b = DependencyContainer_1.DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Error(DevicesService.ServiceName, "Unknown error occured when trying to execute task on device. Error code: " + result_4.Data);
                                            res = TaskExecutionResult_1.DeviceTaskExecutionResult.Failed;
                                            break;
                                    }
                                    break;
                            }
                            var pos = 0;
                            var info = new IDevicesService_1.DeviceTaskPairExecutionResult();
                            for (var _i = 0, tasks_4 = tasks; _i < tasks_4.length; _i++) {
                                var _c = tasks_4[_i], device = _c[0], task = _c[1];
                                if (pos == responsePosition_1) {
                                    info.Device = device;
                                    info.Task = task;
                                    info.Channel = task.Channel;
                                    results.push(info);
                                    break;
                                }
                                else
                                    pos++;
                            }
                        });
                        return [3 /*break*/, 4];
                    case 3:
                        ex_6 = _k.sent();
                        if (ex_6.message.includes("timeout")) {
                            (_c = DependencyContainer_1.DependencyContainer.Log) === null || _c === void 0 ? void 0 : _c.Error(DevicesService.ServiceName, "Failed to get controller response in time.\n" + ex_6);
                            for (_f = 0, tasks_2 = tasks; _f < tasks_2.length; _f++) {
                                _g = tasks_2[_f], device = _g[0], task = _g[1];
                                info = new IDevicesService_1.DeviceTaskPairExecutionResult();
                                results.push(info);
                                info.Device = device;
                                info.Task = task;
                                info.Channel = task.Channel;
                                info.Result = TaskExecutionResult_1.DeviceTaskExecutionResult.ControllerResponseTimeout;
                            }
                        }
                        else {
                            (_d = DependencyContainer_1.DependencyContainer.Log) === null || _d === void 0 ? void 0 : _d.Error(DevicesService.ServiceName, "Unknown error occured when tried to execute task on device.\n" + ex_6);
                            for (_h = 0, tasks_3 = tasks; _h < tasks_3.length; _h++) {
                                _j = tasks_3[_h], device = _j[0], task = _j[1];
                                info = new IDevicesService_1.DeviceTaskPairExecutionResult();
                                results.push(info);
                                info.Device = device;
                                info.Task = task;
                                info.Channel = task.Channel;
                                info.Result = TaskExecutionResult_1.DeviceTaskExecutionResult.Failed;
                            }
                        }
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, results];
                }
            });
        });
    };
    DevicesService.ServiceName = "DevicesService";
    return DevicesService;
}());
exports.DevicesService = DevicesService;
var DeviceChannelStates = /** @class */ (function () {
    function DeviceChannelStates() {
        this.Channel = 0;
        this.States = [];
    }
    return DeviceChannelStates;
}());
var DeviceObject = /** @class */ (function () {
    function DeviceObject() {
        this.Guid = "";
        this.CloudGuid = "";
        this.DeviceSerialNumber = "";
        this.DeviceModelGuid = "";
        this.ProtocolGuid = "";
        this.DeviceName = "";
        this.DeviceModel = "";
        this.ManufacturerGuid = "";
        this.ChannelsNumber = 0;
        this.IsVirtual = false;
        this.IsEnabled = false;
        this.DeviceState = IDevice_1.DeviceState.Working;
        this.CommunicationWay = IDevice_1.CommunicationWay.OneWay;
        this.DeviceType = IDevice_1.DeviceType.Unknown;
        this.ChannelsConfiguration = [];
        this.Groups = [];
        this.AvailableTasks = [];
        this.AvailableResponses = [];
    }
    return DeviceObject;
}());
var DeviceGroupObject = /** @class */ (function () {
    function DeviceGroupObject() {
        this.Guid = "";
        this.Name = "";
    }
    return DeviceGroupObject;
}());
var ChannelConfigurationObject = /** @class */ (function () {
    function ChannelConfigurationObject() {
        this.Channel = 0;
        this.ChannelName = "";
        this.Configuration = IDeviceChannel_1.ChannelConfigurations.Default;
        this.Configurations = {};
        this.CustomData = {};
        this.Roles = [];
        this.IconName = "";
        this.GroupsGuids = [];
        this.Hidden = false;
        this.AvailableTasks = [];
        this.AvailableResponses = [];
    }
    return ChannelConfigurationObject;
}());
var GetDevicesListRequest = /** @class */ (function (_super) {
    __extends(GetDevicesListRequest, _super);
    function GetDevicesListRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/list";
        _this.Method = DataFrame_1.Method.Get;
        return _this;
    }
    return GetDevicesListRequest;
}(DataFrame_1.DataFrame));
var GetDevicesStatesRequest = /** @class */ (function (_super) {
    __extends(GetDevicesStatesRequest, _super);
    function GetDevicesStatesRequest() {
        var _this = _super.call(this) || this;
        _this.Data = false;
        _this.Resource = "/devices/channels/states";
        _this.Method = DataFrame_1.Method.Get;
        return _this;
    }
    return GetDevicesStatesRequest;
}(DataFrame_1.DataFrame));
var SyncDevicesStatesRequest = /** @class */ (function (_super) {
    __extends(SyncDevicesStatesRequest, _super);
    function SyncDevicesStatesRequest() {
        var _this = _super.call(this) || this;
        _this.Data = false;
        _this.Resource = "/devices/channels/states/sync";
        _this.Method = DataFrame_1.Method.Get;
        return _this;
    }
    return SyncDevicesStatesRequest;
}(DataFrame_1.DataFrame));
var SearchForDevicesRequest = /** @class */ (function (_super) {
    __extends(SearchForDevicesRequest, _super);
    function SearchForDevicesRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/search";
        _this.Method = DataFrame_1.Method.Post;
        return _this;
    }
    return SearchForDevicesRequest;
}(DataFrame_1.DataFrame));
var StopSearchingForDevicesRequest = /** @class */ (function (_super) {
    __extends(StopSearchingForDevicesRequest, _super);
    function StopSearchingForDevicesRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/search/stop";
        _this.Method = DataFrame_1.Method.Post;
        return _this;
    }
    return StopSearchingForDevicesRequest;
}(DataFrame_1.DataFrame));
var GetFoundDevicesRequest = /** @class */ (function (_super) {
    __extends(GetFoundDevicesRequest, _super);
    function GetFoundDevicesRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/found/list";
        _this.Method = DataFrame_1.Method.Get;
        return _this;
    }
    return GetFoundDevicesRequest;
}(DataFrame_1.DataFrame));
/**
 * @type Class
 */
var DeviceStateChangedObject = /** @class */ (function () {
    function DeviceStateChangedObject() {
        this.DeviceGuid = "";
        this.state = new DeviceStateObject();
        this.Type = 0;
        this.DataType = "";
    }
    return DeviceStateChangedObject;
}());
exports.DeviceStateChangedObject = DeviceStateChangedObject;
/**
 * @type Class
 */
var DeviceStateObject = /** @class */ (function () {
    function DeviceStateObject() {
        this.Channel = 0;
        this.StateReliability = IDeviceState_1.StateReliability.Unconfident;
    }
    return DeviceStateObject;
}());
exports.DeviceStateObject = DeviceStateObject;
var GetRunningDevicesTasksRequest = /** @class */ (function (_super) {
    __extends(GetRunningDevicesTasksRequest, _super);
    function GetRunningDevicesTasksRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/tasks";
        _this.Method = DataFrame_1.Method.Get;
        return _this;
    }
    return GetRunningDevicesTasksRequest;
}(DataFrame_1.DataFrame));
var DevicePairRequest = /** @class */ (function (_super) {
    __extends(DevicePairRequest, _super);
    function DevicePairRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/pair";
        _this.Method = DataFrame_1.Method.Put;
        return _this;
    }
    return DevicePairRequest;
}(DataFrame_1.DataFrame));
var DeviceUnpairRequest = /** @class */ (function (_super) {
    __extends(DeviceUnpairRequest, _super);
    function DeviceUnpairRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/unpair";
        _this.Method = DataFrame_1.Method.Put;
        return _this;
    }
    return DeviceUnpairRequest;
}(DataFrame_1.DataFrame));
var ForceDeviceUnpairRequest = /** @class */ (function (_super) {
    __extends(ForceDeviceUnpairRequest, _super);
    function ForceDeviceUnpairRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/unpair/force";
        _this.Method = DataFrame_1.Method.Put;
        return _this;
    }
    return ForceDeviceUnpairRequest;
}(DataFrame_1.DataFrame));
var ExecuteDeviceTaskRequest = /** @class */ (function (_super) {
    __extends(ExecuteDeviceTaskRequest, _super);
    function ExecuteDeviceTaskRequest(task) {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/control";
        _this.Method = DataFrame_1.Method.Post;
        _this.Data = task;
        return _this;
    }
    return ExecuteDeviceTaskRequest;
}(DataFrame_1.DataFrame));
var ExecuteDevicesTasksRequest = /** @class */ (function (_super) {
    __extends(ExecuteDevicesTasksRequest, _super);
    function ExecuteDevicesTasksRequest(tasks) {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/devices/control";
        _this.Method = DataFrame_1.Method.Post;
        _this.Data = tasks;
        return _this;
    }
    return ExecuteDevicesTasksRequest;
}(DataFrame_1.DataFrame));
var DeviceIsUsedInScenesRequest = /** @class */ (function (_super) {
    __extends(DeviceIsUsedInScenesRequest, _super);
    function DeviceIsUsedInScenesRequest(guid) {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/device/used";
        _this.Method = DataFrame_1.Method.Get;
        _this.Data = guid;
        return _this;
    }
    return DeviceIsUsedInScenesRequest;
}(DataFrame_1.DataFrame));
var DeviceTaskInfo = /** @class */ (function () {
    function DeviceTaskInfo() {
        this.DeviceGuid = "";
        this.Channel = 0;
        this.ControlFeature = IDeviceTask_1.DeviceControlFeature.GetState;
        /// does't exist in controller, its is used only by this library to map responses that are returned in order to tasks
        this.SequnceExecutionOrder = 0;
    }
    return DeviceTaskInfo;
}());
var LightColorTaskInfo = /** @class */ (function (_super) {
    __extends(LightColorTaskInfo, _super);
    function LightColorTaskInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.R = 0;
        _this.G = 0;
        _this.B = 0;
        return _this;
    }
    return LightColorTaskInfo;
}(DeviceTaskInfo));
var LightRGBWTaskInfo = /** @class */ (function (_super) {
    __extends(LightRGBWTaskInfo, _super);
    function LightRGBWTaskInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.R = 0;
        _this.G = 0;
        _this.B = 0;
        _this.W = 0;
        _this.Brightness = 0;
        return _this;
    }
    return LightRGBWTaskInfo;
}(DeviceTaskInfo));
var FacadePositionTaskInfo = /** @class */ (function (_super) {
    __extends(FacadePositionTaskInfo, _super);
    function FacadePositionTaskInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.FacadeAction = Tasks_1.FacadeActionEnum.Stop;
        _this.Tilt = 0;
        _this.Position = 0;
        return _this;
    }
    return FacadePositionTaskInfo;
}(DeviceTaskInfo));
var DevicesTaskExecutionApiResult = /** @class */ (function () {
    function DevicesTaskExecutionApiResult() {
        this.DeviceGuid = "";
        this.Status = DataFrame_1.Status.OK;
    }
    return DevicesTaskExecutionApiResult;
}());
var DeviceUsedInScenesResponse = /** @class */ (function () {
    function DeviceUsedInScenesResponse() {
        this.DeviceGuid = "";
        this.ConditionsAsCondition = [];
        this.ConditionsAsTask = [];
    }
    return DeviceUsedInScenesResponse;
}());
/**
 * @type Class
 */
var DeviceUsedInScenes = /** @class */ (function () {
    function DeviceUsedInScenes() {
        this.DeviceGuid = "";
        this.ConditionsAsCondition = [];
        this.ConditionsAsTask = [];
    }
    return DeviceUsedInScenes;
}());
exports.DeviceUsedInScenes = DeviceUsedInScenes;
//# sourceMappingURL=DevicesService.js.map