import { Status } from "../DataFrame";
import { IDIService } from "../IDIService";
export interface IRemoteStorageService extends IDIService {
    SaveAsync(resourceGuid: string, isGlobalForAllUsers: boolean, data: any): Promise<Status>;
    ReadAsync<T>(resourceGuid: string, isGlobalForAllUsers: boolean, skipLocalChache: boolean): Promise<RemoteStorageDataEntry<T> | Status>;
    RemoveAsync(resourceGuid: string, isGlobalForAllUsers: boolean): Promise<Status>;
}
export declare class RemoteStorageDataEntry<T> {
    ResourceGuid: string;
    Data: T;
    IsGlobal: boolean;
    InsertTime: Date;
}
