import { ImageType, IPicture } from "./IPicture";
/**
 * Picture object
 * Base64Image - encoded image
 * OwnerGuid - guid of owner (coud be user, device etc..)
 * OwnerIdentity - custom identifier to recognise images within the same GUID (channels of device, profile image of user, etc...).
 */
export declare class Picture implements IPicture {
    protected _guid: string;
    protected _ownerGuid: string;
    protected _ownerIdentity: string;
    protected _base64Image: string;
    protected _imageType: ImageType;
    protected _dateTime: string;
    get Guid(): string;
    get OwnerGuid(): string;
    get OwnerIdentity(): string;
    get Base64Image(): string;
    get ImageType(): ImageType;
    get DateTime(): string;
    set Base64Image(value: string);
    set Guid(value: string);
    set OwnerGuid(value: string);
    set OwnerIdentity(value: string);
    set ImageType(value: ImageType);
}
