import { Status } from "../../DataFrame";
import { ResponseResult } from "../FieldChangeResult";
import { IPicture, IPictureInfo } from "./IPicture";
import { IPicturesService } from "./IPicturesService";
import { Picture } from "./Picture";
export declare class PicturesService implements IPicturesService {
    static readonly ServiceName: string;
    private _connection;
    private _logger;
    private _imageExistsCaseNumber;
    constructor();
    GetServiceName(): string;
    AddPictureAsync(picture: Picture): Promise<Status>;
    EditPictureAsync(picture: Picture): Promise<Status>;
    DeletePictureAsync(picture: Picture): Promise<Status>;
    GetPicturesInfoAsync(): Promise<IPictureInfo[] | ResponseResult<Status>>;
    GetPictureAsync(pictureGuid: string): Promise<IPicture | ResponseResult<Status>>;
    GetPicturesListAsync(): Promise<ResponseResult<Status> | IPicture[]>;
}
