import { DataFrame, Status } from '../DataFrame';
import { IRemoteStorageService, RemoteStorageDataEntry } from './IRemoteStorageService';
export declare class RemoteStorageService implements IRemoteStorageService {
    static readonly ServiceName: string;
    private _connection;
    private _localDb;
    constructor();
    private GetLocalDbName;
    SaveAsync(resourceGuid: string, isGlobalForAllUsers: boolean, data: any): Promise<Status>;
    ReadAsync<T>(resourceGuid: string, isGlobalForAllUsers: boolean, skipLocalChache: boolean): Promise<RemoteStorageDataEntry<T> | Status>;
    RemoveAsync(resourceGuid: string, isGlobalForAllUsers: boolean): Promise<Status>;
    GetServiceName(): string;
}
export declare class RemoteStorageDataEntryResponse extends DataFrame<string> {
    ResourceGuid: string;
    Data: string;
    IsGlobal: boolean;
    InsertTime: Date;
}
