"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try {
            step(generator.next(value));
        }
        catch (e) {
            reject(e);
        } }
        function rejected(value) { try {
            step(generator["throw"](value));
        }
        catch (e) {
            reject(e);
        } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function () { if (t[0] & 1)
            throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f)
            throw new TypeError("Generator is already executing.");
        while (_)
            try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                    return t;
                if (y = 0, t)
                    op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0:
                    case 1:
                        t = op;
                        break;
                    case 4:
                        _.label++;
                        return { value: op[1], done: false };
                    case 5:
                        _.label++;
                        y = op[1];
                        op = [0];
                        continue;
                    case 7:
                        op = _.ops.pop();
                        _.trys.pop();
                        continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                            _ = 0;
                            continue;
                        }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                            _.label = op[1];
                            break;
                        }
                        if (op[0] === 6 && _.label < t[1]) {
                            _.label = t[1];
                            t = op;
                            break;
                        }
                        if (t && _.label < t[2]) {
                            _.label = t[2];
                            _.ops.push(op);
                            break;
                        }
                        if (t[2])
                            _.ops.pop();
                        _.trys.pop();
                        continue;
                }
                op = body.call(thisArg, _);
            }
            catch (e) {
                op = [6, e];
                y = 0;
            }
            finally {
                f = t = 0;
            }
        if (op[0] & 5)
            throw op[1];
        return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.ScenesService = void 0;
var Api_1 = require("../../Api");
var DataFrame_1 = require("../../DataFrame");
var Guid_1 = require("../../Guid");
var Helpers_1 = require("../../Helpers");
var ControllerConfigurationService_1 = require("../Controller/ControllerConfigurationService");
var GeolocationService_1 = require("../Controller/GeolocationService");
var IGeolocationService_1 = require("../Controller/IGeolocationService");
var DevicesService_1 = require("../Devices/DevicesService");
var IDevice_1 = require("../Devices/IDevice");
var IDeviceState_1 = require("../Devices/IDeviceState");
var IDeviceTask_1 = require("../Devices/IDeviceTask");
var TaskExecutionResult_1 = require("../Devices/TaskExecutionResult");
var DeviceTask_1 = require("../Devices/Tasks/DeviceTask");
var Tasks_1 = require("../Devices/Tasks/Tasks");
var ExalusConnectionService_1 = require("../ExalusConnectionService");
var FieldChangeResult_1 = require("../FieldChangeResult");
var LoggerService_1 = require("../Logging/LoggerService");
var IScenesService_1 = require("./IScenesService");
var LeftArgumentTypes_1 = require("./LeftArgumentTypes");
var Scenes_1 = require("./Scenes");
var ScenesBuilder_1 = require("./ScenesBuilder");
/**
 * @type Class
 */
var ScenesService = /** @class */ (function () {
    function ScenesService() {
        this._connection = Api_1.Api.Get(ExalusConnectionService_1.ExalusConnectionService.ServiceName);
        this._configurationService = Api_1.Api.Get(ControllerConfigurationService_1.ControllerConfigurationService.ServiceName);
    }
    ScenesService.prototype.GetServiceName = function () {
        return ScenesService.ServiceName;
    };
    ScenesService.prototype.GetSequencesListAsync = function () {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetSequencesListRequest(), 12000, false))];
                    case 1:
                        result = _b.sent();
                        Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Debug("GetSequencesListAsync result:\n " + JSON.stringify(result) + "}");
                        if (result == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IScenesService_1.ScenesServiceErrorCode.OtherError, "Cannot get sequences list - response is null.")];
                        if (result.Status != DataFrame_1.Status.OK)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IScenesService_1.ScenesServiceErrorCode.OtherError, "Cannot get sequences list - controller responded with response code " + result.Status + ".")];
                        if (result.Data == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IScenesService_1.ScenesServiceErrorCode.NoData, "Cannot get sequences list - controller responded with status OK, but response does not contain data!")];
                        return [2 /*return*/, result.Data];
                }
            });
        });
    };
    ScenesService.prototype.GetSequenceAsync = function (sequence) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var sequenceGuid, result, raw;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        sequenceGuid = "";
                        if (typeof sequence == 'string') {
                            sequenceGuid = sequence;
                        }
                        else {
                            sequenceGuid = sequence.Guid;
                        }
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetSequenceDetailsRequest(sequenceGuid), 12000, false))];
                    case 1:
                        result = _b.sent();
                        if (result == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IScenesService_1.ScenesServiceErrorCode.OtherError, "Cannot get sequence - response is null.")];
                        if (result.Status != DataFrame_1.Status.OK)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IScenesService_1.ScenesServiceErrorCode.OtherError, "Cannot get sequence - controller responded with response code " + result.Status + ".")];
                        if (result.Data == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IScenesService_1.ScenesServiceErrorCode.NoData, "Cannot get sequence - controller responded with status OK, but response does not contain data!")];
                        raw = result.Data;
                        return [2 /*return*/, this.MapSequence(raw)];
                }
            });
        });
    };
    ScenesService.prototype.GetSequenceBuilder = function (newSequenceName, newSequenceIcon) {
        return new ScenesBuilder_1.SequenceBuilder(newSequenceName, newSequenceIcon);
    };
    ScenesService.prototype.CreateSequenceAsync = function (sequence) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var result, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, 4, 6]);
                        return [4 /*yield*/, this._configurationService.EnterConfigurationModeAsync()];
                    case 1:
                        _b.sent();
                        Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Debug("Creating sequence " + sequence.Name + " json: \n" + JSON.stringify(sequence));
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new CreateSequenceRequest(sequence), 20000, false))];
                    case 2:
                        result = _b.sent();
                        if (result == null || result.Status == null)
                            return [2 /*return*/, DataFrame_1.Status.Error];
                        return [2 /*return*/, result.Status];
                    case 3:
                        error_1 = _b.sent();
                        Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Error("Creating sequence " + sequence.Name + " error: " + error_1);
                        return [2 /*return*/, DataFrame_1.Status.FatalError];
                    case 4: return [4 /*yield*/, this._configurationService.ExitConfigurationModeAsync()];
                    case 5:
                        _b.sent();
                        return [7 /*endfinally*/];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ScenesService.prototype.DeleteSequenceAsync = function (sequence) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var sequenceGuid, result, error_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, 4, 6]);
                        sequenceGuid = "";
                        if (typeof sequence == 'string') {
                            sequenceGuid = sequence;
                        }
                        else {
                            sequenceGuid = sequence.Guid;
                        }
                        return [4 /*yield*/, this._configurationService.EnterConfigurationModeAsync()];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new DeleteSequenceRequest(sequenceGuid), 12000, false))];
                    case 2:
                        result = _b.sent();
                        if (result == null || result.Status == null)
                            return [2 /*return*/, DataFrame_1.Status.Error];
                        return [2 /*return*/, result.Status];
                    case 3:
                        error_2 = _b.sent();
                        return [2 /*return*/, DataFrame_1.Status.FatalError];
                    case 4: return [4 /*yield*/, this._configurationService.ExitConfigurationModeAsync()];
                    case 5:
                        _b.sent();
                        return [7 /*endfinally*/];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ScenesService.prototype.EditSequenceAsync = function (sequence) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var request, result, error_3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, 4, 6]);
                        request = {
                            Guid: sequence.Guid,
                            Icon: sequence.Icon,
                            Name: sequence.Name,
                            Condition: sequence
                        };
                        return [4 /*yield*/, this._configurationService.EnterConfigurationModeAsync()];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new EditSequenceRequest(request), 20000, false))];
                    case 2:
                        result = _b.sent();
                        if (result == null || result.Status == null)
                            return [2 /*return*/, DataFrame_1.Status.Error];
                        return [2 /*return*/, result.Status];
                    case 3:
                        error_3 = _b.sent();
                        Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Error("Editing sequence " + sequence.Name + " error: " + error_3);
                        return [2 /*return*/, DataFrame_1.Status.FatalError];
                    case 4: return [4 /*yield*/, this._configurationService.ExitConfigurationModeAsync()];
                    case 5:
                        _b.sent();
                        return [7 /*endfinally*/];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ScenesService.prototype.EnableSequenceAsync = function (sequence) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var sequenceGuid, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        sequenceGuid = "";
                        if (typeof sequence == 'string') {
                            sequenceGuid = sequence;
                        }
                        else {
                            sequenceGuid = sequence.Guid;
                        }
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new EnableSequenceRequest(sequenceGuid), 12000, false))];
                    case 1:
                        result = _b.sent();
                        if (result == null || result.Status == null)
                            return [2 /*return*/, DataFrame_1.Status.Error];
                        return [2 /*return*/, result.Status];
                }
            });
        });
    };
    ScenesService.prototype.DisableSequenceAsync = function (sequence) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var sequenceGuid, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        sequenceGuid = "";
                        if (typeof sequence == 'string') {
                            sequenceGuid = sequence;
                        }
                        else {
                            sequenceGuid = sequence.Guid;
                        }
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new DisableSequenceRequest(sequenceGuid), 12000, false))];
                    case 1:
                        result = _b.sent();
                        if (result == null || result.Status == null)
                            return [2 /*return*/, DataFrame_1.Status.Error];
                        return [2 /*return*/, result.Status];
                }
            });
        });
    };
    ScenesService.prototype.RunSequenceAsync = function (sequence) {
        return __awaiter(this, void 0, Promise, function () {
            var sequenceDeviceGuid, res, seq, tsk, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        sequenceDeviceGuid = "";
                        if (!(typeof sequence == 'string'))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, this.GetSequencesListAsync()];
                    case 1:
                        res = _a.sent();
                        if (res.Type != null)
                            return [2 /*return*/, DataFrame_1.Status.Error];
                        else {
                            seq = res.find(function (s) { return s.Guid == sequence; });
                            if (!seq)
                                return [2 /*return*/, DataFrame_1.Status.Error];
                            sequenceDeviceGuid = seq.DeviceGuid;
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        sequenceDeviceGuid = sequence.DeviceGuid;
                        _a.label = 3;
                    case 3:
                        tsk = new Tasks_1.TurnOn();
                        tsk.Channel = 1;
                        tsk.DeviceGuid = sequenceDeviceGuid;
                        return [4 /*yield*/, Api_1.Api.Get(DevicesService_1.DevicesService.ServiceName).ExecuteDeviceTaskAsync({ Guid: sequenceDeviceGuid }, tsk)];
                    case 4:
                        result = _a.sent();
                        switch (result) {
                            case TaskExecutionResult_1.DeviceTaskExecutionResult.Executed:
                                return [2 /*return*/, DataFrame_1.Status.OK];
                            case TaskExecutionResult_1.DeviceTaskExecutionResult.DeviceNotFound:
                                return [2 /*return*/, DataFrame_1.Status.WrongData];
                            default:
                                return [2 /*return*/, DataFrame_1.Status.Error];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ScenesService.prototype.GetUtilsAsync = function () {
        return __awaiter(this, void 0, Promise, function () {
            var astronomicalClockSunCalc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.SunCalculatorAsync()];
                    case 1:
                        astronomicalClockSunCalc = _a.sent();
                        return [2 /*return*/, {
                                GetSunRiseTime: astronomicalClockSunCalc.GetSunRiseTime,
                                GetSunSetTime: astronomicalClockSunCalc.GetSunSetTime,
                                ParseLinearScaleToLux: this._parseLinearScaleToLux,
                                ParseLuxToLinearScale: this._parseLuxToLinearScale
                            }];
                }
            });
        });
    };
    ScenesService.prototype._parseLinearScaleToLux = function (linearScaleVal) {
        if (linearScaleVal < 0.0 || linearScaleVal > 1.0)
            return undefined;
        return Math.round(Math.pow(10, (linearScaleVal * 5)));
    };
    ScenesService.prototype._parseLuxToLinearScale = function (lux) {
        if (lux <= 0)
            return 0;
        var res = (Math.log10(lux) / 5.0);
        return res > 1.0 ? 1 : res;
    };
    ScenesService.prototype.SunCalculatorAsync = function () {
        return __awaiter(this, void 0, Promise, function () {
            var srv, cords, recalculationDone, controlerCords, error_4, hasDST, calculateDifferenceSunAndLocalTime, calculateDeclination, calculateTanSunPosition, calculateSunRiseInternal, calculateSunSetInternal, createDateTime, calclateSunRise, calculateSunSet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        srv = Api_1.Api.Get(GeolocationService_1.GeolocationService.ServiceName);
                        cords = new IGeolocationService_1.Coordinates();
                        recalculationDone = false;
                        cords.Latitude = 49.9958888026741;
                        cords.Longitude = 18.9172596008914;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        return [4 /*yield*/, srv.IsControllerGeolocationSetAsync()];
                    case 2:
                        if (!_a.sent())
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, srv.GetControlllerGeolocationAsync()];
                    case 3:
                        controlerCords = _a.sent();
                        if (controlerCords instanceof IGeolocationService_1.CoordinatesWithSourceInfo) {
                            cords.Latitude = controlerCords.Latitude;
                            cords.Longitude = controlerCords.Longitude;
                        }
                        _a.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        error_4 = _a.sent();
                        Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Warning("Cannot get localization data, using default values: 49.9958888026741, 18.9172596008914. Error: " + error_4);
                        return [3 /*break*/, 6];
                    case 6:
                        hasDST = function (date) {
                            if (date === void 0) {
                                date = new Date();
                            }
                            var january = new Date(date.getFullYear(), 0, 1).getTimezoneOffset();
                            var july = new Date(date.getFullYear(), 6, 1).getTimezoneOffset();
                            return Math.max(january, july) !== date.getTimezoneOffset();
                        };
                        calculateDifferenceSunAndLocalTime = function (dayNumberOfDateTime) {
                            var ellipticalOrbitPart1 = 7.95204 * Math.sin((0.01768 * dayNumberOfDateTime) + 3.03217);
                            var ellipticalOrbitPart2 = 9.98906 * Math.sin((0.03383 * dayNumberOfDateTime) + 3.46870);
                            var differenceSunAndLocalTime = ellipticalOrbitPart1 + ellipticalOrbitPart2 + (cords.Longitude - Math.round(cords.Longitude / 15) * 15) * 4;
                            if (hasDST())
                                differenceSunAndLocalTime -= 60;
                            return differenceSunAndLocalTime;
                        };
                        calculateDeclination = function (numberOfDaysSinceFirstOfJanuary) {
                            return Math.asin(-0.39795 * Math.cos(2.0 * Math.PI * (numberOfDaysSinceFirstOfJanuary + 10.0) / 365.0));
                        };
                        calculateTanSunPosition = function (declanationOfTheSun) {
                            var limitTanSunPosition = function (tanSunPosition) {
                                if (tanSunPosition < -1)
                                    tanSunPosition = -1.0;
                                if (tanSunPosition > 1)
                                    tanSunPosition = 1.0;
                                return tanSunPosition;
                            };
                            var latitudeRadians = cords.Latitude * Math.PI / 180;
                            var sinSunPosition = Math.sin(latitudeRadians) * Math.sin(declanationOfTheSun);
                            var cosSunPosition = Math.cos(latitudeRadians) * Math.cos(declanationOfTheSun);
                            var tanSunPosition = sinSunPosition / cosSunPosition;
                            tanSunPosition = limitTanSunPosition(tanSunPosition);
                            return tanSunPosition;
                        };
                        calculateSunRiseInternal = function (tanSunPosition, differenceSunAndLocalTime) {
                            var sunRise = (720.0 - 720.0 / Math.PI * Math.acos(-tanSunPosition) - differenceSunAndLocalTime);
                            if (sunRise < 0)
                                sunRise += 1440;
                            return sunRise;
                        };
                        calculateSunSetInternal = function (tanSunPosition, differenceSunAndLocalTime) {
                            var sunSet = (720.0 + 720.0 / Math.PI * Math.acos(-tanSunPosition) - differenceSunAndLocalTime);
                            if (sunSet > 1439)
                                sunSet -= 1439;
                            return sunSet;
                        };
                        createDateTime = function (timeInMinutes) {
                            var hour = Math.ceil(timeInMinutes / 60);
                            var minute = timeInMinutes - (hour * 60);
                            var now = new Date();
                            return new Date(now.getFullYear(), now.getMonth(), now.getDate(), hour, minute);
                        };
                        calclateSunRise = function (offset) {
                            var dat = new Date();
                            dat.setDate(dat.getDate() + offset);
                            var calculateDayOfYear = function (date) { return Math.floor((date.valueOf() - new Date(date.getFullYear(), 0, 0).valueOf()) / 1000 / 60 / 60 / 24); };
                            var dayNumberOfDateTime = calculateDayOfYear(dat);
                            var differenceSunAndLocalTime = calculateDifferenceSunAndLocalTime(dayNumberOfDateTime);
                            var declanationOfTheSun = calculateDeclination(dayNumberOfDateTime);
                            var tanSunPosition = calculateTanSunPosition(declanationOfTheSun);
                            var sunRiseInMinutes = calculateSunRiseInternal(tanSunPosition, differenceSunAndLocalTime);
                            var result = createDateTime(sunRiseInMinutes);
                            if (new Date() > result && !recalculationDone) {
                                recalculationDone = true;
                                return calclateSunRise(1);
                            }
                            else {
                                recalculationDone = false;
                                return new Date(dat.getFullYear(), dat.getMonth(), dat.getDate(), result.getHours(), result.getMinutes());
                            }
                        };
                        calculateSunSet = function (offset) {
                            var dat = new Date();
                            dat.setDate(dat.getDate() + offset);
                            var calculateDayOfYear = function (date) { return Math.floor((date.valueOf() - new Date(date.getFullYear(), 0, 0).valueOf()) / 1000 / 60 / 60 / 24); };
                            var dayNumberOfDateTime = calculateDayOfYear(dat);
                            var differenceSunAndLocalTime = calculateDifferenceSunAndLocalTime(dayNumberOfDateTime);
                            var declanationOfTheSun = calculateDeclination(dayNumberOfDateTime);
                            var tanSunPosition = calculateTanSunPosition(declanationOfTheSun);
                            var sunRiseInMinutes = Math.floor(calculateSunSetInternal(tanSunPosition, differenceSunAndLocalTime));
                            var result = createDateTime(sunRiseInMinutes);
                            if (new Date() > result && !recalculationDone) {
                                recalculationDone = true;
                                return calculateSunSet(1);
                            }
                            else {
                                recalculationDone = false;
                                return new Date(dat.getFullYear(), dat.getMonth(), dat.getDate(), result.getHours(), result.getMinutes());
                            }
                        };
                        return [2 /*return*/, {
                                GetSunRiseTime: function () { return calclateSunRise(0); },
                                GetSunSetTime: function () { return calculateSunSet(0); }
                            }];
                }
            });
        });
    };
    ScenesService.prototype.MapSequence = function (rawSequenceResponse, ignoreRightArgument) {
        if (ignoreRightArgument === void 0) {
            ignoreRightArgument = false;
        }
        //Copy all values that are unchanged between raw and typed Sequence object
        var data = __assign({}, rawSequenceResponse);
        //Create temporary task guid - it allows to remove single task in builder, task guids are not supported by backend so it exists only in library
        //Here we also here handle task backward compatibility issue - remap DeviceTasks to ControllerTasks
        var findLastRightArgumentAndRefactorTasks = function (rawSequence) {
            var _a, _b;
            //Last arg
            if (rawSequence.RightArgumentType == ArgumentTypeNum.Null) {
                //Remap DeviceTasks to ControllerTasks - this coude coud be removed in future
                if (!Object.hasOwn(rawSequence.Tasks, "ControllerTasks") && Object.hasOwn(rawSequence.Tasks, "DevicesTasks")) {
                    delete Object.assign(rawSequence.Tasks, (_a = {}, _a["ControllerTasks"] = rawSequence.Tasks["DevicesTasks"], _a))["DevicesTasks"];
                    rawSequence.Tasks.ControllerTasks.map(function (t) {
                        t.TaskType = Scenes_1.SceneTaskTypeNum.DeviceTask;
                        t.RunParallel = false;
                    });
                }
            }
            else {
                if (!Object.hasOwn(rawSequence.Tasks, "ControllerTasks") && Object.hasOwn(rawSequence.Tasks, "DevicesTasks")) {
                    delete Object.assign(rawSequence.Tasks, (_b = {}, _b["ControllerTasks"] = rawSequence.Tasks["DevicesTasks"], _b))["DevicesTasks"];
                }
                return findLastRightArgumentAndRefactorTasks(rawSequence.RightArgument);
            }
        };
        findLastRightArgumentAndRefactorTasks(rawSequenceResponse);
        data._rawRequestData = JSON.parse(JSON.stringify(rawSequenceResponse));
        //Preform mappings for correct types
        if (!ignoreRightArgument) {
            data.RightArgumentType = this.MapArgumentType(rawSequenceResponse.RightArgumentType);
            data.RightArgument = this.MapRightArgument(rawSequenceResponse.RightArgument, data.RightArgumentType);
        }
        else {
            data.RightArgument = null;
            data.RightArgumentType = Scenes_1.ArgumentType.Null;
        }
        data.LeftArgumentType = this.MapArgumentType(rawSequenceResponse.LeftArgumentType);
        data.LeftArgument = this.MapLeftArgument(rawSequenceResponse.LeftArgument, data.LeftArgumentType);
        data.Tasks.ControllerTasks = this.MapControllerTasks(rawSequenceResponse.Tasks.ControllerTasks);
        if (data.DoesHaveTriggers === undefined) {
            data.DoesHaveTriggers = data.LeftArgumentType == Scenes_1.ArgumentType.Null;
        }
        return data;
    };
    /**
     * Functions map all nested right arguments recursively
     * @param arg
     * @returns
     */
    ScenesService.prototype.MapRightArgument = function (arg, argType) {
        if (arg.HandledType == 0)
            return arg;
        arg.LeftArgumentType = this.MapArgumentType(arg.LeftArgumentType);
        arg.LeftArgument = this.MapLeftArgument(arg.LeftArgument, arg.LeftArgumentType);
        arg.Tasks.ControllerTasks = this.MapControllerTasks(arg.Tasks.ControllerTasks);
        //Remove old taks if exists
        if (Object.hasOwn(arg.Tasks, "DevicesTasks"))
            delete arg.Tasks["DevicesTasks"];
        switch (argType) {
            case Scenes_1.ArgumentType.Condition:
                arg.RightArgumentType = this.MapArgumentType(arg.RightArgumentType);
                arg.RightArgument = this.MapRightArgument(arg.RightArgument, arg.RightArgumentType);
        }
        return arg;
    };
    /**
     * Function maps raw LeftArgument JSON to object-key typed parameters property
     * @param arg
     * @returns
     */
    ScenesService.prototype.MapLeftArgument = function (arg, argType) {
        var result = new LeftArgument();
        result.HandledType = arg.HandledType;
        switch (argType) {
            case Scenes_1.ArgumentType.ArgumentAsAstronomicalClock: {
                result.Argument.ArgumentAsAstronomicalClock = {
                    Position: arg.Argument
                };
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsAstronomicalClockWithOffset: {
                result.Argument.ArgumentAsAstronomicalClockWithOffset = {
                    Offset: arg.Argument.Offset,
                    Position: arg.Argument.Position
                };
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsBoolean: {
                result.Argument.ArgumentAsBoolean = arg.Argument;
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsDayOfWeek: {
                result.Argument.ArgumentAsDayOfWeek = arg.Argument;
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsDaysOfWeek: {
                result.Argument.ArgumentAsDaysOfWeek = arg.Argument;
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsInt: {
                result.Argument.ArgumentAsInt = arg.Argument;
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsTimeout: {
                result.Argument.ArgumentAsTimeout = arg.Argument;
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsTimeSpan: {
                result.Argument.ArgumentAsTimeSpan = {
                    days: arg.Argument.days,
                    hours: arg.Argument.hours,
                    minutes: arg.Argument.minutes,
                    seconds: arg.Argument.seconds
                };
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsTime: {
                result.Argument.ArgumentAsTime = {
                    Hour: arg.Argument.Hour,
                    Minute: arg.Argument.Minute,
                    Second: arg.Argument.Second
                };
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsDeviceState: {
                var devStateArg_1 = new LeftArgumentTypes_1.DeviceStateArgument();
                devStateArg_1.Type = this.MapDeviceStateTypeToResponseType(arg.Argument.DeviceStateType);
                devStateArg_1.SetCheckDeviceState(this.CreateDeviceState(arg.Argument.CheckedDeviceState, arg.Argument.Channel, devStateArg_1.Type));
                devStateArg_1.DeviceGuid = arg.Argument.DeviceGuid;
                devStateArg_1.ComparisonMethod = arg.Argument.ComparisonMethod == undefined ? LeftArgumentTypes_1.DeviceStateComparisonMethod.Default : arg.Argument.ComparisonMethod;
                if (arg.Argument.ComparisonParams != null) {
                    Object.entries(arg.Argument.ComparisonParams).forEach(function (k) {
                        switch (k[0]) {
                            case "DeltaValue":
                            case "StateRepeatCount":
                                devStateArg_1.SetComparisonParam(LeftArgumentTypes_1.DeviceStateComparisonParams[k[0]], new LeftArgumentTypes_1.NumberParam(k[1]));
                                break;
                            case "DeltaCalculationTimeRange":
                            case "StateRepeatTimeRange":
                                devStateArg_1.SetComparisonParam(LeftArgumentTypes_1.DeviceStateComparisonParams[k[0]], new LeftArgumentTypes_1.TimeSpanParam(k[1]));
                                break;
                        }
                    });
                }
                result.Argument.ArgumentAsDeviceState = devStateArg_1;
                break;
            }
            case Scenes_1.ArgumentType.ArgumentAsConditionInfo: {
                result.Argument.ArgumentAsConditionInfo = {
                    DeviceGuid: arg.Argument.DeviceGuid
                };
                break;
            }
        }
        return result;
    };
    /**
     * Function changes numeric based enum to string based enum, string enum is more user frienldy and is used for key of left argument typed property
     * @param argumentType
     * @returns
     */
    ScenesService.prototype.MapArgumentType = function (argumentType) {
        return Scenes_1.ArgumentType[ArgumentTypeNum[argumentType]];
    };
    /**
     * Maps types of device state from Scenes extension state enum to general device states enum in library
     * @param stateType
     * @returns
     */
    ScenesService.prototype.MapDeviceStateTypeToResponseType = function (stateType) {
        switch (stateType) {
            case Scenes_1.DeviceStateType.BatteryState:
                return IDevice_1.DeviceResponseType.BatteryState;
            case Scenes_1.DeviceStateType.BinarySensor:
                return IDevice_1.DeviceResponseType.BinarySensorState;
            case Scenes_1.DeviceStateType.BlindPosition:
                return IDevice_1.DeviceResponseType.BlindPosition;
            case Scenes_1.DeviceStateType.Brightness:
                return IDevice_1.DeviceResponseType.MeasuredBrightness;
            case Scenes_1.DeviceStateType.ButtonState:
                return IDevice_1.DeviceResponseType.RemoteButtonState;
            case Scenes_1.DeviceStateType.ChannelOnOff:
                return IDevice_1.DeviceResponseType.ChannelOnOffState;
            case Scenes_1.DeviceStateType.DoorBell:
                return IDevice_1.DeviceResponseType.DoorBellState;
            case Scenes_1.DeviceStateType.Energy:
                return IDevice_1.DeviceResponseType.MeasuredEnergy;
            case Scenes_1.DeviceStateType.FloodSensor:
                return IDevice_1.DeviceResponseType.FloodSensorState;
            case Scenes_1.DeviceStateType.GatePosition:
                return IDevice_1.DeviceResponseType.GatePosition;
            //case DeviceStateType.HeatSensor:
            //  return DeviceResponseType.
            case Scenes_1.DeviceStateType.LightBrightness:
                return IDevice_1.DeviceResponseType.LightBrightness;
            case Scenes_1.DeviceStateType.LightColor:
                return IDevice_1.DeviceResponseType.LightColor;
            case Scenes_1.DeviceStateType.LightTemperature:
                return IDevice_1.DeviceResponseType.LightWarmth;
            //case DeviceStateType.MeasuredCurrent:
            //    return DeviceResponseType.
            //case DeviceStateType.MeasuredPower:
            //    return DeviceResponseType
            // case DeviceStateType.MeasuredVoltage:
            //    return DeviceResponseType.
            case Scenes_1.DeviceStateType.ReedState:
                return IDevice_1.DeviceResponseType.ReedState;
            case Scenes_1.DeviceStateType.SmokeSensor:
                return IDevice_1.DeviceResponseType.SmokeSensorState;
            case Scenes_1.DeviceStateType.Temperature:
                return IDevice_1.DeviceResponseType.MeasuredTemperature;
            case Scenes_1.DeviceStateType.Humidity:
                return IDevice_1.DeviceResponseType.HumiditySensorState;
            case Scenes_1.DeviceStateType.BlindsControlButton:
                return IDevice_1.DeviceResponseType.BlindRemoteButtonState;
            case Scenes_1.DeviceStateType.FacadeControlButton:
                return IDevice_1.DeviceResponseType.FacadeRemoteButtonState;
            case Scenes_1.DeviceStateType.Movement:
                return IDevice_1.DeviceResponseType.MovementSensorState;
            case Scenes_1.DeviceStateType.AirPressure:
                return IDevice_1.DeviceResponseType.PressureSensorState;
            case Scenes_1.DeviceStateType.WindSpeed:
                return IDevice_1.DeviceResponseType.WindSpeedState;
            case Scenes_1.DeviceStateType.WindThreshold:
                return IDevice_1.DeviceResponseType.CurrentWindThreshold;
            default:
                return IDevice_1.DeviceResponseType.Unknown;
        }
    };
    /**
     * Function converts device state from Scenes extension to general device states in library
     * @param argumentData
     * @param responseType
     * @returns
     */
    ScenesService.prototype.CreateDeviceState = function (argumentData, channel, responseType) {
        switch (responseType) {
            case IDevice_1.DeviceResponseType.BatteryState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Percentage: argumentData.Percentage,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.BinarySensorState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.BlindPosition: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Position: argumentData.Position,
                    RawPosition: argumentData.RawPosition,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.LightBrightness: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Brightness: argumentData.Brightness,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.MeasuredBrightness: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Brightness: argumentData.Brightness,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.RemoteButtonState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.ChannelOnOffState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.DoorBellState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.MeasuredEnergy: {
                var params = new Map();
                for (var _i = 0, _a = Object.entries(argumentData.MeasurementParameters); _i < _a.length; _i++) {
                    var _b = _a[_i], k = _b[0], v = _b[1];
                    params.set(IDeviceState_1.EnergyMeasurementParameter[k], v);
                }
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    MeasurementParameters: params,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.FloodSensorState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.GatePosition: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Position: argumentData.Position,
                    PositionType: argumentData.PositionType,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.LightColor: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    R: argumentData.R,
                    G: argumentData.G,
                    B: argumentData.B,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.LightWarmth: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Temperature: argumentData.Temperature,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.ReedState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.SmokeSensorState:
                throw new Scenes_1.UnsupportedScenesDeviceState("Unsupported device state!");
            case IDevice_1.DeviceResponseType.MeasuredTemperature: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Temperature: argumentData.Temperature,
                    Time: "",
                    Type: argumentData.Type
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.HumiditySensorState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Humidity: argumentData.Humidity,
                    Time: "",
                    Type: argumentData.Type
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.BlindRemoteButtonState: {
                var state = {
                    Channel: channel,
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State,
                    Time: ""
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.LightRGBWState: {
                var state = {
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Channel: channel,
                    Time: "",
                    Brightness: 100,
                    R: argumentData.R,
                    G: argumentData.G,
                    B: argumentData.B,
                    W: argumentData.W
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.FacadeRemoteButtonState: {
                var state = {
                    Channel: channel,
                    Time: "",
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    State: argumentData.State
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.MovementSensorState: {
                var state = {
                    Channel: channel,
                    Time: "",
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Movement: argumentData.Movement,
                    Intensity: argumentData.Intensity
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.PressureSensorState: {
                var state = {
                    Channel: channel,
                    Time: "",
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Pressure: argumentData.Pressure,
                    PressureType: argumentData.PressureType
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.WindSpeedState: {
                var state = {
                    Channel: channel,
                    Time: "",
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    Value: argumentData.Value
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.CurrentWindThreshold: {
                var state = {
                    Channel: channel,
                    Time: "",
                    StateReliability: IDeviceState_1.StateReliability.Unconfident,
                    WindThreshold: argumentData.WindThreshold
                };
                return state;
            }
            case IDevice_1.DeviceResponseType.Unknown:
                return new IDeviceState_1.DeviceState();
            default:
                throw new Scenes_1.UnsupportedScenesDeviceState("Unsupported device state!");
        }
    };
    ScenesService.prototype.MapDeviceTask = function (rawTasks) {
        var result = new DeviceTask_1.DeviceTask();
        var tsk = rawTasks;
        Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Debug("[TASK] object: " + JSON.stringify(tsk));
        switch (tsk.ControlFeature) {
            case IDeviceTask_1.DeviceControlFeature.TurnOn: {
                result = new Tasks_1.TurnOn();
                result.TaskType = IDevice_1.DeviceTaskType.TurnOn;
                break;
            }
            case IDeviceTask_1.DeviceControlFeature.TurnOff: {
                result = new Tasks_1.TurnOff();
                result.TaskType = IDevice_1.DeviceTaskType.TurnOff;
                break;
            }
            case IDeviceTask_1.DeviceControlFeature.ToggleState: {
                result = new Tasks_1.ToggleState();
                result.TaskType = IDevice_1.DeviceTaskType.TogleState;
                break;
            }
            case IDeviceTask_1.DeviceControlFeature.SetBlindPosition:
                result = new Tasks_1.SetBlindPosition();
                result.TaskType = IDevice_1.DeviceTaskType.SetBlindPosition;
                result.Action = tsk.Data.Action;
                result.Position = tsk.Data.Position;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightColor:
                result = new Tasks_1.SetLightColor();
                result.TaskType = IDevice_1.DeviceTaskType.SetLightColor;
                result.R = tsk.Data.R;
                result.G = tsk.Data.G;
                result.B = tsk.Data.B;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightTemperature:
                result = new Tasks_1.SetLightTemperature();
                result.TaskType = IDevice_1.DeviceTaskType.SetLightTemperature;
                result.Temperature = tsk.Data.Temperature;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightBrightness:
                result = new Tasks_1.SetLightBrightness();
                result.TaskType = IDevice_1.DeviceTaskType.SetLightBrightness;
                result.Brightness = tsk.Data.Brightness;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetTemperature:
                result = new Tasks_1.SetTemperature();
                result.TaskType = IDevice_1.DeviceTaskType.SetTemperature;
                result.Temperature = tsk.Data.Temperature;
                break;
            case IDeviceTask_1.DeviceControlFeature.GetState:
                result = new Tasks_1.GetDeviceState();
                result.TaskType = IDevice_1.DeviceTaskType.GetChannelsState;
                break;
            case IDeviceTask_1.DeviceControlFeature.TurnOnWithTimeout:
                result = new Tasks_1.TurnOnWithTime();
                result.TaskType = IDevice_1.DeviceTaskType.TurnOnWithTime;
                result.SwitchOffDelaySeconds = tsk.Data.SwitchOffDelaySeconds;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetLightBrightnessDynamicly:
                result = new Tasks_1.SetLightBrightnessDynamicly();
                result.TaskType = IDevice_1.DeviceTaskType.SetLightBrightnessDynamicly;
                result.Brightness = tsk.Data.Brightness;
                break;
            case IDeviceTask_1.DeviceControlFeature.IdentifyDevice:
                result = new Tasks_1.IdentifyDevice();
                result.TaskType = IDevice_1.DeviceTaskType.IdentifyDevice;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetBlindOpenCloseTime:
                result = new Tasks_1.SetBlindOpenCloseTime();
                result.TaskType = IDevice_1.DeviceTaskType.SetBlindOpenCloseTime;
                result.Data.CloseTime = tsk.Data;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetBlindMicroventilation:
                result = new Tasks_1.SetBlindMicroventilation();
                result.TaskType = IDevice_1.DeviceTaskType.SetBlindMicroventilation;
                result.Position = tsk.Data.Position;
                break;
            case IDeviceTask_1.DeviceControlFeature.GatewayPulse:
                result = new Tasks_1.ChangeGatewayPositionPulse();
                result.TaskType = IDevice_1.DeviceTaskType.ChangeGatewayPositionPulse;
                break;
            case IDeviceTask_1.DeviceControlFeature.GatePulse:
                result = new Tasks_1.ChangeGatePositionPulse();
                result.TaskType = IDevice_1.DeviceTaskType.ChangeGatePositionPulse;
                break;
            case IDeviceTask_1.DeviceControlFeature.SetFacadePositionAndTilt:
                result = new Tasks_1.SetFacadePosition();
                result.TaskType = IDevice_1.DeviceTaskType.SetFacadePosition;
                result.Position = tsk.Data.Position;
                result.Tilt = tsk.Data.Tilt;
                result.FacadeAction = Tasks_1.FacadeActionEnum.TiltAndPercentage;
                break;
            case IDeviceTask_1.DeviceControlFeature.GetFacadeType:
                result = new Tasks_1.GetFacadeType();
                result.TaskType = IDevice_1.DeviceTaskType.GetFacadeType;
                break;
            case IDeviceTask_1.DeviceControlFeature.LightRGBW:
                result = new Tasks_1.LightRGBW();
                result.TaskType = IDevice_1.DeviceTaskType.LightRGBW;
                result.Data = tsk.Data;
                break;
            default:
                break;
        }
        result.Channel = tsk.Channel;
        result.DeviceGuid = tsk.DeviceGuid;
        result.FeatureType = tsk.ControlFeature;
        result.Guid = Guid_1.Guid.NewGuid();
        return result;
    };
    ScenesService.prototype.MapControllerTasks = function (rawTasks) {
        var result = [];
        Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Debug("[TASKS] received tasks object: " + JSON.stringify(rawTasks));
        for (var _i = 0, _a = rawTasks; _i < _a.length; _i++) {
            var tsk = _a[_i];
            var task = new ControllerTasks();
            task.TaskId = Helpers_1.Helpers.GenerateMd5(JSON.stringify(tsk));
            switch (tsk.TaskType) {
                case Scenes_1.SceneTaskTypeNum.DeviceTask:
                    task.TaskType = Scenes_1.SceneTaskType.DeviceTask;
                    task.Task.DeviceTask = this.MapDeviceTask(tsk);
                    break;
                case Scenes_1.SceneTaskTypeNum.DelayTask:
                    task.TaskType = Scenes_1.SceneTaskType.DelayTask;
                    task.Task.DelayTask = {
                        Delay: new LeftArgumentTypes_1.TimeSpanParam(tsk.Delay)
                    };
                    break;
                case Scenes_1.SceneTaskTypeNum.NotifyTask:
                    task.TaskType = Scenes_1.SceneTaskType.NotifyTask;
                    task.Task.NotifyTask = {
                        Title: tsk.Title,
                        Message: tsk.Message,
                        NotifyType: tsk.NotifyType
                    };
                    break;
                case Scenes_1.SceneTaskTypeNum.LockExecution:
                case Scenes_1.SceneTaskTypeNum.LockExecution:
                    task.TaskType = Scenes_1.SceneTaskType.LockExecution;
                    Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName).Debug("[TASKS] received task LockExecution object: " + JSON.stringify(tsk));
                    task.Task.LockExecution = {
                        LockStartHour: new LeftArgumentTypes_1.TimeSpanParam(tsk.LockStartHour),
                        LockEndHour: new LeftArgumentTypes_1.TimeSpanParam(tsk.LockEndHour),
                        LockType: tsk.LockType,
                        ResetLockScenesGuids: tsk.ResetLockScenesGuids
                    };
                    break;
                case Scenes_1.SceneTaskTypeNum.Unknown:
                    break;
            }
            result.push(task);
        }
        return result;
    };
    ScenesService.ServiceName = "ScenesService";
    return ScenesService;
}());
exports.ScenesService = ScenesService;
//Sequences list
var GetSequencesListRequest = /** @class */ (function (_super) {
    __extends(GetSequencesListRequest, _super);
    function GetSequencesListRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/sequences/list";
        _this.Method = DataFrame_1.Method.Get;
        return _this;
    }
    return GetSequencesListRequest;
}(DataFrame_1.DataFrame));
//Sequence details
var GetSequenceDetailsRequest = /** @class */ (function (_super) {
    __extends(GetSequenceDetailsRequest, _super);
    function GetSequenceDetailsRequest(sequenceGuid) {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/sequence";
        _this.Method = DataFrame_1.Method.Get;
        _this.Data = sequenceGuid;
        return _this;
    }
    return GetSequenceDetailsRequest;
}(DataFrame_1.DataFrame));
var Sequence = /** @class */ (function () {
    function Sequence() {
        this._rawRequestData = new ScenesBuilder_1.SequenceRequestData();
        this.Tasks = { ControllerTasks: [] };
        this.Guid = "";
        this.ObjectType = 1;
        this.Name = "";
        this.Icon = "";
        this.AtMeetCondition = false;
        this.ExecuteOnce = false;
        this.IsDisabled = false;
        this.HandledType = Scenes_1.HandledType.Unknown;
        this.ConditionType = Scenes_1.ConditionsTypes.Unknown;
        this.ConditionTimeout = 0;
        this.LeftArgumentType = Scenes_1.ArgumentType.Null;
        this.RightArgumentType = Scenes_1.ArgumentType.Null;
        this.LeftArgument = new LeftArgument();
        this.RightArgument = null;
    }
    Object.defineProperty(Sequence.prototype, "DoesHaveTriggers", {
        get: function () {
            return this.LeftArgumentType == Scenes_1.ArgumentType.Null;
        },
        enumerable: false,
        configurable: true
    });
    return Sequence;
}());
var LeftArgument = /** @class */ (function () {
    function LeftArgument() {
        this.HandledType = ArgumentTypeNum.Null;
        this.Argument = {};
    }
    return LeftArgument;
}());
var ArgumentTypeNum;
(function (ArgumentTypeNum) {
    ArgumentTypeNum[ArgumentTypeNum["Null"] = 0] = "Null";
    ArgumentTypeNum[ArgumentTypeNum["Condition"] = 1] = "Condition";
    ArgumentTypeNum[ArgumentTypeNum["ConditionGroup"] = 2] = "ConditionGroup";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsInt"] = 3] = "ArgumentAsInt";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsTimeSpan"] = 4] = "ArgumentAsTimeSpan";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsBoolean"] = 5] = "ArgumentAsBoolean";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsTimeout"] = 6] = "ArgumentAsTimeout";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsDayOfWeek"] = 7] = "ArgumentAsDayOfWeek";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsDaysOfWeek"] = 8] = "ArgumentAsDaysOfWeek";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsAstronomicalClock"] = 9] = "ArgumentAsAstronomicalClock";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsTime"] = 10] = "ArgumentAsTime";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsDeviceState"] = 11] = "ArgumentAsDeviceState";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsNumber"] = 12] = "ArgumentAsNumber";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsAstronomicalClockWithOffset"] = 13] = "ArgumentAsAstronomicalClockWithOffset";
    ArgumentTypeNum[ArgumentTypeNum["ArgumentAsConditionInfo"] = 14] = "ArgumentAsConditionInfo";
})(ArgumentTypeNum || (ArgumentTypeNum = {}));
var ControllerTasks = /** @class */ (function () {
    function ControllerTasks() {
        this.TaskId = "";
        this.TaskType = Scenes_1.SceneTaskType.Unknown;
        this.Task = {};
    }
    return ControllerTasks;
}());
//Create sequence
var CreateSequenceRequest = /** @class */ (function (_super) {
    __extends(CreateSequenceRequest, _super);
    function CreateSequenceRequest(data) {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/sequence";
        _this.Method = DataFrame_1.Method.Put;
        _this.Data = data;
        return _this;
    }
    return CreateSequenceRequest;
}(DataFrame_1.DataFrame));
//Edit sequence
var EditSequenceRequest = /** @class */ (function (_super) {
    __extends(EditSequenceRequest, _super);
    function EditSequenceRequest(data) {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/sequence/edit";
        _this.Method = DataFrame_1.Method.Put;
        _this.Data = data;
        return _this;
    }
    return EditSequenceRequest;
}(DataFrame_1.DataFrame));
var EditSequenceRequestFrame = /** @class */ (function () {
    function EditSequenceRequestFrame() {
        this.Guid = "";
        this.Icon = "";
        this.Name = "";
        this.Condition = new ScenesBuilder_1.SequenceRequestData();
    }
    return EditSequenceRequestFrame;
}());
//Delete sequence
var DeleteSequenceRequest = /** @class */ (function (_super) {
    __extends(DeleteSequenceRequest, _super);
    function DeleteSequenceRequest(sequenceGuid) {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/sequence";
        _this.Method = DataFrame_1.Method.Delete;
        _this.Data = sequenceGuid;
        return _this;
    }
    return DeleteSequenceRequest;
}(DataFrame_1.DataFrame));
//Enable sequence
var EnableSequenceRequest = /** @class */ (function (_super) {
    __extends(EnableSequenceRequest, _super);
    function EnableSequenceRequest(sequenceGuid) {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/sequence/enable";
        _this.Method = DataFrame_1.Method.Post;
        _this.Data = sequenceGuid;
        return _this;
    }
    return EnableSequenceRequest;
}(DataFrame_1.DataFrame));
//Disable sequence
var DisableSequenceRequest = /** @class */ (function (_super) {
    __extends(DisableSequenceRequest, _super);
    function DisableSequenceRequest(sequenceGuid) {
        var _this = _super.call(this) || this;
        _this.Resource = "/logic/sequence/disable";
        _this.Method = DataFrame_1.Method.Post;
        _this.Data = sequenceGuid;
        return _this;
    }
    return DisableSequenceRequest;
}(DataFrame_1.DataFrame));
//# sourceMappingURL=ScenesService.js.map