import { IDIService } from "../../IDIService";
export interface ISupportedDevicesService extends IDIService {
    GetSupportedDevices(language: Language): SupportedDevice[];
}
export declare enum Language {
    En_US = "en-US",
    En_GB = "en-GB",
    De_DE = "de-DE",
    Fr_FR = "fr-FR",
    It_IT = "it-IT",
    Es_ES = "es-ES",
    Nl_NL = "nl-NL",
    Pl_PL = "pl-PL",
    Unknown = "en-US"
}
export declare enum ProductType {
    Unknown = 0,
    Remote = 1,
    BlindController = 2,
    LightController = 3,
    HeatingController = 4,
    FacadeBlindController = 5,
    GateController = 6,
    DoorController = 7,
    GatewayController = 8,
    Sensor = 9,
    SwitchController = 10,
    Conuters = 11,
    Cameras = 12,
    Intercoms = 13
}
export declare class SupportedDevice {
    ModelGuid: string;
    RequiresController: boolean;
    ModelName: string;
    ManufacturerGuid: string;
    ManufacturerName: string;
    DeviceProtocolGuid: string;
    DeviceProtocolName: string;
    ProductGroups: string[];
    ProductTypes: ProductType[];
    Name: string;
    Description: string;
    PromoVideo: string | null;
    Pictures: string[];
    ShowAsDeviceDemo: boolean;
    WhereToBuy: ExternalSite[];
    ManualsAndDocuments: Document[];
    Videos: Video[];
}
export declare class ExternalSite {
    Id: string;
    Name: string;
    Link: string;
}
export declare class Video {
    Id: string;
    Title: string;
    Link: string;
}
export declare class Document {
    Id: string;
    Title: string;
    Link: string;
}
