import { IDeviceUpdateProvider } from "./IDeviceUpdateProvider";
import { IUpdateProvider } from "./IUpdateProvider";
export declare class DeviceUpdateProvider implements IUpdateProvider {
    static readonly ServiceName: string;
    private _services;
    private _runtimeInfo;
    private _isRuntimeInfoInitialized;
    GetServiceName(): string;
    GetSoftwareRuntimeInfoAsync(reloadCachedData?: boolean): Promise<SoftwareRuntimeInfo>;
    RegisterUpdateProvider(service: IDeviceUpdateProvider): void;
    GetUpdateProviderAsync<T extends IDeviceUpdateProvider>(serviceName: string, forceReloadExtensions?: boolean): Promise<T>;
    GetUpdateProvidersAsync<T extends IDeviceUpdateProvider>(protocolGuid: string, apiVersion?: string | undefined): Promise<T[]>;
    protected GetRuntimeControllerInfoAsync(): Promise<void>;
}
export declare class SoftwareRuntimeInfo {
    BaseLinuxVersion: string;
    BaseMonoVersion: string;
    RuntimeVersion: string;
    UpdateChannel: string;
    SoftwareVersion: string;
}
export declare class DeviceUpdateProviderNotFound extends Error {
    message: string;
    constructor(message: string);
}
export declare class CannotGetRuntimeInfo extends Error {
    message: string;
    constructor(message: string);
}
