import { Status } from "../../DataFrame";
import { IDevice } from "../Devices/IDevice";
import { ResponseResult } from "../FieldChangeResult";
import { ICustomUpdateActions } from "./CustomUpdateActions/ICustomUpdateActions";
import { UpdateInfo } from "./IUpdateProvider";
import { UpdateAction, UpdateErrorCode, UpdateProgress } from "./IUpdatesService";
export interface IDeviceUpdateProvider {
    get ProtocolExtensionGuid(): string;
    get ProtocolGuid(): string;
    get AvailableExtensionVersion(): string;
    get AvailableApiVersion(): string;
    GetUpdateProviderName(): string;
    GetAvailableUpdateAsync(device: IDevice): Promise<UpdateInfo | ResponseResult<UpdateErrorCode>>;
    InstallUpdateAsync<T extends ICustomUpdateActions>(update: UpdateInfo, updateProgress: UpdateProgress, updateAction?: UpdateAction<T>): Promise<Status.OK | ResponseResult<UpdateErrorCode>>;
    GetSoftwareVersionAsync(device: IDevice): Promise<string | ResponseResult<UpdateErrorCode>>;
}
