import { IDIService } from "../../IDIService";
import { SoftwareRuntimeInfo } from "./DeviceUpdateProvider";
import { IDeviceUpdateProvider } from "./IDeviceUpdateProvider";
export interface IUpdateProvider extends IDIService {
    GetSoftwareRuntimeInfoAsync(reloadCachedData?: boolean): Promise<SoftwareRuntimeInfo>;
    RegisterUpdateProvider(service: IDeviceUpdateProvider): void;
    GetUpdateProviderAsync<T extends IDeviceUpdateProvider>(serviceName: string): Promise<T>;
    GetUpdateProvidersAsync<T extends IDeviceUpdateProvider>(protocolGuid: string, apiVersion?: string): Promise<T[]>;
}
export declare class Update {
    UpdateGuid: string;
    Channel: string;
    Version: string;
    CurrentVersion: string;
    DownloadUri: string;
    Download: string;
    Name: string;
    Description: string;
    UpdateType: UpdateTypes;
    ResourceGuid: string;
}
export declare class UpdateInfo {
    Update: Update;
    UpdatedResourceName: string;
    CurrentResourceVersion: string;
}
export declare enum UpdateTypes {
    Unknown = 0,
    Container = 1,
    RadioFirmware = 2,
    DeviceFirmware = 3,
    Configuration = 4,
    ContainerScript = 5,
    ContainerSoftware = 6,
    RuntimeSoftware = 7,
    RuntimeScript = 8,
    RuntimeFixingScript = 9
}
