"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try {
            step(generator.next(value));
        }
        catch (e) {
            reject(e);
        } }
        function rejected(value) { try {
            step(generator["throw"](value));
        }
        catch (e) {
            reject(e);
        } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function () { if (t[0] & 1)
            throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f)
            throw new TypeError("Generator is already executing.");
        while (_)
            try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                    return t;
                if (y = 0, t)
                    op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0:
                    case 1:
                        t = op;
                        break;
                    case 4:
                        _.label++;
                        return { value: op[1], done: false };
                    case 5:
                        _.label++;
                        y = op[1];
                        op = [0];
                        continue;
                    case 7:
                        op = _.ops.pop();
                        _.trys.pop();
                        continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                            _ = 0;
                            continue;
                        }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                            _.label = op[1];
                            break;
                        }
                        if (op[0] === 6 && _.label < t[1]) {
                            _.label = t[1];
                            t = op;
                            break;
                        }
                        if (t && _.label < t[2]) {
                            _.label = t[2];
                            _.ops.push(op);
                            break;
                        }
                        if (t[2])
                            _.ops.pop();
                        _.trys.pop();
                        continue;
                }
                op = body.call(thisArg, _);
            }
            catch (e) {
                op = [6, e];
                y = 0;
            }
            finally {
                f = t = 0;
            }
        if (op[0] & 5)
            throw op[1];
        return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.ControllerUpdateNotAvailableInfo = exports.UpdatesService = void 0;
var Api_1 = require("../../Api");
var DataFrame_1 = require("../../DataFrame");
var ControllerExtensionsService_1 = require("../Controller/ControllerExtensionsService");
var DevicesService_1 = require("../Devices/DevicesService");
var FieldChangeResult_1 = require("../FieldChangeResult");
var UpdatesProvider_1 = require("./UpdatesProvider");
var IUpdateInfo_1 = require("./IUpdateInfo");
var IUpdatesProvider_1 = require("./IUpdatesProvider");
var IUpdatesService_1 = require("./IUpdatesService");
var AppStateService_1 = require("../AppStateService");
var LoggerService_1 = require("../Logging/LoggerService");
var ExalusConnectionService_1 = require("../ExalusConnectionService");
var Helpers_1 = require("../../Helpers");
/**
 * @type Class
 */
var UpdatesService = /** @class */ (function () {
    function UpdatesService() {
        this._controllerUpdates = [];
        this._updateRequestTimeout = 120000;
        this._updateProviders = Api_1.Api.Get(UpdatesProvider_1.UpdatesProvider.ServiceName);
        this._logger = Api_1.Api.Get(LoggerService_1.LoggerService.ServiceName);
        this._connection = Api_1.Api.Get(ExalusConnectionService_1.ExalusConnectionService.ServiceName);
        this._appStateService = Api_1.Api.Get(AppStateService_1.AppStateService.ServiceName);
        this._extensionService = Api_1.Api.Get(ControllerExtensionsService_1.ControllerExtensionsService.ServiceName);
    }
    UpdatesService.prototype.GetServiceName = function () {
        return UpdatesService.ServiceName;
    };
    UpdatesService.prototype.CheckDeviceVersionAsync = function (dev) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var device, result, softwareInfo;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(typeof dev == 'string'))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, Api_1.Api.Get(DevicesService_1.DevicesService.ServiceName).GetDevice(dev)];
                    case 1:
                        result = _b.sent();
                        if (result != null)
                            device = result;
                        else
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotFindDevice, "Device with specified GUID " + dev + " does not exists.")];
                        return [3 /*break*/, 3];
                    case 2:
                        device = dev;
                        _b.label = 3;
                    case 3:
                        if (device.ProtocolGuid == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.UnsupportedDevice, "Device does not contains data about protocol GUID.")];
                        return [4 /*yield*/, this._updateProviders.GetUpdatesProvidersByProtocolAsync(device.ProtocolGuid, IUpdatesProvider_1.ProviderType.Device)];
                    case 4: return [4 /*yield*/, ((_a = (_b.sent()).first()) === null || _a === void 0 ? void 0 : _a.GetSoftwareVersionAsync(device))];
                    case 5:
                        softwareInfo = _b.sent();
                        if (softwareInfo.Type != null)
                            return [2 /*return*/, softwareInfo];
                        return [2 /*return*/, softwareInfo];
                }
            });
        });
    };
    UpdatesService.prototype.CheckDeviceUpdateAsync = function (dev) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var device, result_1, updateInfo, result, protocol, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(typeof dev == 'string'))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, Api_1.Api.Get(DevicesService_1.DevicesService.ServiceName).GetDevice(dev)];
                    case 1:
                        result_1 = _b.sent();
                        if (result_1 != null)
                            device = result_1;
                        else
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotFindDevice, "Device with specified GUID " + dev + " does not exists.")];
                        return [3 /*break*/, 3];
                    case 2:
                        device = dev;
                        _b.label = 3;
                    case 3:
                        if (device.ProtocolGuid == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.UnsupportedDevice, "Device does not contains data about protocol GUID.")];
                        return [4 /*yield*/, this._updateProviders.GetUpdatesProvidersByProtocolAsync(device.ProtocolGuid, IUpdatesProvider_1.ProviderType.Device)];
                    case 4: return [4 /*yield*/, ((_a = (_b.sent()).first()) === null || _a === void 0 ? void 0 : _a.GetAvailableUpdateAsync(device))];
                    case 5:
                        updateInfo = _b.sent();
                        if (updateInfo.Type != null)
                            return [2 /*return*/, updateInfo];
                        result = new DeviceUpdate();
                        result.CurrentResourceVersion = updateInfo.CurrentResourceVersion;
                        result.NewResourceVersion = updateInfo.Update.Version;
                        result.UpdatedResourceName = updateInfo.UpdatedResourceName;
                        result.UpdateResourceGuid = updateInfo.Update.ResourceGuid;
                        result.UpdateDescription = new Map([["pl-PL", updateInfo.Update.Description]]);
                        protocol = "n/a";
                        _b.label = 6;
                    case 6:
                        _b.trys.push([6, 8, , 9]);
                        return [4 /*yield*/, this._extensionService.GetProtocolInfoAsync(device.ProtocolGuid)];
                    case 7:
                        protocol = (_b.sent()).first().Name;
                        return [3 /*break*/, 9];
                    case 8:
                        error_1 = _b.sent();
                        this._logger.Warning("Cannot get protocol name! error: " + error_1);
                        return [3 /*break*/, 9];
                    case 9:
                        result.Protocol = protocol;
                        result.ProtocolGuid = device.ProtocolGuid;
                        return [4 /*yield*/, Api_1.Api.Get(DevicesService_1.DevicesService.ServiceName).GetDevicesAsync()];
                    case 10:
                        if ((_b.sent()).any(function (dev) { return dev.ModelGuid == "952ddc14-76c4-4f47-b0bc-5d106c1f9b02"; }))
                            result.IsUpdateSafe = false;
                        return [2 /*return*/, result];
                }
            });
        });
    };
    UpdatesService.prototype.InstallDeviceUpdateAsync = function (dev, updateProgress, updateAction) {
        var _a;
        return __awaiter(this, void 0, Promise, function () {
            var device, result, updateInfo, updateInstallResult;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(typeof dev == 'string'))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, Api_1.Api.Get(DevicesService_1.DevicesService.ServiceName).GetDevice(dev)];
                    case 1:
                        result = _b.sent();
                        if (result != null)
                            device = result;
                        else
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotFindDevice, "Device with specified GUID " + dev + " does not exists.")];
                        return [3 /*break*/, 3];
                    case 2:
                        device = dev;
                        _b.label = 3;
                    case 3:
                        if (device.ProtocolGuid == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.UnsupportedDevice, "Device does not contains data about protocol GUID.")];
                        return [4 /*yield*/, this._updateProviders.GetUpdatesProvidersByProtocolAsync(device.ProtocolGuid, IUpdatesProvider_1.ProviderType.Device)];
                    case 4: return [4 /*yield*/, ((_a = (_b.sent()).first()) === null || _a === void 0 ? void 0 : _a.GetAvailableUpdateAsync(device))];
                    case 5:
                        updateInfo = _b.sent();
                        if (updateInfo.Type != null)
                            return [2 /*return*/, updateInfo];
                        this._appStateService.DisallowHibernation();
                        return [4 /*yield*/, this._updateProviders.GetUpdatesProvidersByProtocolAsync(device.ProtocolGuid, IUpdatesProvider_1.ProviderType.Device)];
                    case 6: return [4 /*yield*/, (_b.sent()).first().InstallUpdateAsync(updateInfo, updateProgress, updateAction)];
                    case 7:
                        updateInstallResult = _b.sent();
                        if (updateInstallResult.Type != null) {
                            this._appStateService.AllowHibernation();
                            return [2 /*return*/, updateInstallResult];
                        }
                        this._appStateService.AllowHibernation();
                        return [2 /*return*/, DataFrame_1.Status.OK];
                }
            });
        });
    };
    UpdatesService.prototype.CheckControllerUpdatesAsync = function () {
        return __awaiter(this, void 0, Promise, function () {
            var updateProviderServices, updates, i, result, error, protocol, error_2, _a, updateInfo, update, runtimeInfo, url, response, updateData, updateInfo, error, _b, update, err_1, runtimeInfo_1, error;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this._updateProviders.GetUpdatesProvidersAsync(IUpdatesProvider_1.ProviderType.Controller)];
                    case 1:
                        updateProviderServices = _c.sent();
                        updates = new IUpdateInfo_1.ControllerUpdatesInfo();
                        this._controllerUpdates = [];
                        i = 0;
                        _c.label = 2;
                    case 2:
                        if (!(i < updateProviderServices.length))
                            return [3 /*break*/, 11];
                        return [4 /*yield*/, updateProviderServices[i].GetAvailableRadioUpdateAsync()];
                    case 3:
                        result = _c.sent();
                        if (!(result.Type != null))
                            return [3 /*break*/, 9];
                        error = new ControllerUpdateNotAvailableInfo();
                        error.ResponseResult = result;
                        error.UpdateType = IUpdateInfo_1.ControllerUpdateType.RadioUpdate;
                        protocol = "n/a";
                        _c.label = 4;
                    case 4:
                        _c.trys.push([4, 6, , 7]);
                        return [4 /*yield*/, this._extensionService.GetProtocolInfoAsync(updateProviderServices[i].ProtocolGuid)];
                    case 5:
                        protocol = (_c.sent()).first().Name;
                        return [3 /*break*/, 7];
                    case 6:
                        error_2 = _c.sent();
                        this._logger.Warning("Cannot get protocol name! error: " + error_2);
                        return [3 /*break*/, 7];
                    case 7:
                        error.UpdatedResourceName = protocol;
                        _a = error;
                        return [4 /*yield*/, updateProviderServices[i].GetCurrentRadioVersionAsync()];
                    case 8:
                        _a.CurrentResourceVersion = _c.sent();
                        updates.UpdatesNotAvailable.push(error);
                        return [3 /*break*/, 10];
                    case 9:
                        updateInfo = result;
                        update = new ControllerUpdate();
                        update.UpdatedResourceName = updateInfo.UpdatedResourceName;
                        update.CurrentResourceVersion = updateInfo.CurrentResourceVersion;
                        update.NewResourceVersion = updateInfo.Update.Version;
                        update.UpdateDescription = new Map([["pl-PL", updateInfo.Update.Description]]);
                        update.UpdateType = IUpdateInfo_1.ControllerUpdateType.RadioUpdate;
                        update.UpdateIdentifier = Helpers_1.Helpers.GenerateUUID();
                        updates.UpdatesAvailable.push(update);
                        this._controllerUpdates.push(__assign(__assign({}, updateInfo), { UpdateIdentifier: update.UpdateIdentifier, ProviderName: updateProviderServices[i].GetUpdateProviderName(), UpdateType: IUpdateInfo_1.ControllerUpdateType.RadioUpdate }));
                        _c.label = 10;
                    case 10:
                        i++;
                        return [3 /*break*/, 2];
                    case 11: return [4 /*yield*/, this._updateProviders.GetSoftwareRuntimeInfoAsync()];
                    case 12:
                        runtimeInfo = _c.sent();
                        url = "https://updates.tr7.pl/software/" + runtimeInfo.UpdateChannel + "/" + runtimeInfo.RuntimeVersion + "/" + runtimeInfo.SoftwareVersion + "/update.json";
                        _c.label = 13;
                    case 13:
                        _c.trys.push([13, 21, , 23]);
                        return [4 /*yield*/, fetch(url)];
                    case 14:
                        response = _c.sent();
                        updateData = void 0;
                        updateInfo = new IUpdatesProvider_1.UpdateInfo();
                        error = new ControllerUpdateNotAvailableInfo();
                        error.UpdateType = IUpdateInfo_1.ControllerUpdateType.SoftwareUpdate;
                        error.UpdatedResourceName = "Controller software";
                        _b = response.status;
                        switch (_b) {
                            case 200: return [3 /*break*/, 15];
                            case 404: return [3 /*break*/, 18];
                        }
                        return [3 /*break*/, 19];
                    case 15:
                        if (!(response.body != null))
                            return [3 /*break*/, 17];
                        return [4 /*yield*/, response.json()];
                    case 16:
                        updateData = (_c.sent());
                        _c.label = 17;
                    case 17: return [3 /*break*/, 20];
                    case 18:
                        error.ResponseResult = new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.DeviceIsUpToDate, "Updates not found, controller is already up-to-date.");
                        updates.UpdatesNotAvailable.push(error);
                        return [3 /*break*/, 20];
                    case 19:
                        error.ResponseResult = new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotGetUpdates, "Response status code does not indicate success. Status: " + response.status);
                        updates.UpdatesNotAvailable.push(error);
                        return [3 /*break*/, 20];
                    case 20:
                        if (updateData != null) {
                            updateInfo.CurrentResourceVersion = runtimeInfo.RuntimeVersion + "." + runtimeInfo.SoftwareVersion;
                            updateInfo.UpdatedResourceName = "Controller software";
                            updateInfo.Update = updateData;
                            update = new ControllerUpdate();
                            update.UpdatedResourceName = updateInfo.UpdatedResourceName;
                            update.CurrentResourceVersion = updateInfo.CurrentResourceVersion;
                            update.NewResourceVersion = updateInfo.Update.Version;
                            update.UpdateDescription = new Map([["pl-PL", updateInfo.Update.Description]]);
                            update.UpdateType = IUpdateInfo_1.ControllerUpdateType.SoftwareUpdate;
                            update.UpdateIdentifier = Helpers_1.Helpers.GenerateUUID();
                            updates.UpdatesAvailable.push(update);
                            this._controllerUpdates.push(__assign(__assign({}, updateInfo), { UpdateIdentifier: update.UpdateIdentifier, ProviderName: UpdatesService.ServiceName, UpdateType: IUpdateInfo_1.ControllerUpdateType.SoftwareUpdate }));
                        }
                        else if (response.status == 200)
                            throw (new Error("Cannot get Update Data from response. Status: " + response.status));
                        return [3 /*break*/, 23];
                    case 21:
                        err_1 = _c.sent();
                        return [4 /*yield*/, this._updateProviders.GetSoftwareRuntimeInfoAsync()];
                    case 22:
                        runtimeInfo_1 = (_c.sent());
                        error = new ControllerUpdateNotAvailableInfo();
                        error.UpdateType = IUpdateInfo_1.ControllerUpdateType.SoftwareUpdate;
                        error.UpdatedResourceName = "Controller software";
                        error.ResponseResult = new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotGetUpdates, "Cannot get available updates! " + err_1);
                        error.CurrentResourceVersion = runtimeInfo_1.RuntimeVersion + "." + runtimeInfo_1.SoftwareVersion;
                        updates.UpdatesNotAvailable.push(error);
                        return [3 /*break*/, 23];
                    case 23: return [2 /*return*/, updates];
                }
            });
        });
    };
    UpdatesService.prototype.CheckControllerVersionAsync = function () {
        return __awaiter(this, void 0, Promise, function () {
            var updateProviderServices, result, version, i, _a, protocol, error_3, runtimeInfo;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this._updateProviders.GetUpdatesProvidersAsync(IUpdatesProvider_1.ProviderType.Controller)];
                    case 1:
                        updateProviderServices = _b.sent();
                        result = [];
                        i = 0;
                        _b.label = 2;
                    case 2:
                        if (!(i < updateProviderServices.length))
                            return [3 /*break*/, 9];
                        version = new IUpdateInfo_1.ControllerVersion();
                        _a = version;
                        return [4 /*yield*/, updateProviderServices[i].GetCurrentRadioVersionAsync()];
                    case 3:
                        _a.Version = _b.sent();
                        version.Type = IUpdateInfo_1.ControllerUpdateType.RadioUpdate;
                        protocol = "n/a";
                        _b.label = 4;
                    case 4:
                        _b.trys.push([4, 6, , 7]);
                        return [4 /*yield*/, this._extensionService.GetProtocolInfoAsync(updateProviderServices[i].ProtocolGuid)];
                    case 5:
                        protocol = (_b.sent()).first().Name;
                        return [3 /*break*/, 7];
                    case 6:
                        error_3 = _b.sent();
                        this._logger.Warning("Cannot get protocol name! error: " + error_3);
                        return [3 /*break*/, 7];
                    case 7:
                        version.Resource = protocol;
                        result.push(version);
                        _b.label = 8;
                    case 8:
                        i++;
                        return [3 /*break*/, 2];
                    case 9:
                        //Software updates
                        version = new IUpdateInfo_1.ControllerVersion();
                        version.Resource = "Controller software";
                        version.Type = IUpdateInfo_1.ControllerUpdateType.SoftwareUpdate;
                        return [4 /*yield*/, this._updateProviders.GetSoftwareRuntimeInfoAsync()];
                    case 10:
                        runtimeInfo = (_b.sent());
                        version.Version = runtimeInfo.RuntimeVersion + "." + runtimeInfo.SoftwareVersion;
                        result.push(version);
                        return [2 /*return*/, result];
                }
            });
        });
    };
    UpdatesService.prototype.InstallControllerUpdateAsync = function (param, updateProgress, updateAction) {
        return __awaiter(this, void 0, Promise, function () {
            var regGuid, numberOfUpdates, updateResult, updateToInstall, _a, updateNumberRef_1, updateProgressWrapper, timeout, updatesToInstall_1, result, _loop_1, this_1, i, controlerUpdate_1, updateResult, resultWithError, errors_1;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        regGuid = new RegExp("^[{]?[0-9a-fA-F]{8}-([0-9a-fA-F]{4}-){3}[0-9a-fA-F]{12}[}]?$");
                        numberOfUpdates = this._controllerUpdates.length;
                        //Check if any updates are avaliable
                        if (this._controllerUpdates.length == 0)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotGetUpdates, "Cannot find any updates, make sure you check for available updates by calling CheckControllerUpdateAsync().")];
                        if (!((typeof param === 'string') && regGuid.test(param)))
                            return [3 /*break*/, 8];
                        updateResult = void 0;
                        updateToInstall = this._controllerUpdates.find(function (update) { return update.UpdateIdentifier == param; });
                        if (updateToInstall == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotGetUpdates, "Update with requested guid (" + param + ") not found.")];
                        this._logger.Debug("Installing single update type: " + updateToInstall.Update.UpdateType + ", resource: " + updateToInstall.UpdatedResourceName + ", version: " + updateToInstall.Update.Version);
                        this._appStateService.DisallowHibernation();
                        _a = updateToInstall.UpdateType;
                        switch (_a) {
                            case IUpdateInfo_1.ControllerUpdateType.RadioUpdate: return [3 /*break*/, 1];
                            case IUpdateInfo_1.ControllerUpdateType.SoftwareUpdate: return [3 /*break*/, 4];
                        }
                        return [3 /*break*/, 6];
                    case 1: return [4 /*yield*/, this._updateProviders.GetUpdatesProviderAsync(updateToInstall.ProviderName)];
                    case 2: return [4 /*yield*/, (_b.sent()).InstallRadioUpdateAsync(updateToInstall, updateProgress, updateAction)];
                    case 3:
                        updateResult = _b.sent();
                        this._appStateService.AllowHibernation();
                        if (updateResult == DataFrame_1.Status.OK)
                            this._controllerUpdates = this._controllerUpdates.filter(function (update) { return update.UpdateIdentifier != param; });
                        return [2 /*return*/, updateResult];
                    case 4: return [4 /*yield*/, this.UpdateControllerAsync(updateToInstall.Update, updateProgress)];
                    case 5:
                        updateResult = _b.sent();
                        this._appStateService.AllowHibernation();
                        if (updateResult == DataFrame_1.Status.OK)
                            this._controllerUpdates = this._controllerUpdates.filter(function (update) { return update.UpdateIdentifier != param; });
                        return [2 /*return*/, updateResult];
                    case 6: return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Update with type " + updateToInstall.UpdateType + " is not supported by UpdateService.")];
                    case 7: return [3 /*break*/, 15];
                    case 8:
                        updateNumberRef_1 = [1];
                        updateProgressWrapper = function (progressInfo) {
                            progressInfo.UpdateNumber = updateNumberRef_1[0];
                            progressInfo.AvailableUpdates = numberOfUpdates;
                            var callback = param;
                            callback(progressInfo);
                        };
                        timeout = function (ms) {
                            return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    return [2 /*return*/, new Promise(function (resolve) { return setTimeout(resolve, ms); })];
                                });
                            });
                        };
                        updatesToInstall_1 = this._controllerUpdates.where(function (update) { return update.UpdateType == IUpdateInfo_1.ControllerUpdateType.RadioUpdate; }).toArray();
                        result = [];
                        this._appStateService.DisallowHibernation();
                        _loop_1 = function (i) {
                            var updateResult;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this_1._updateProviders.GetUpdatesProviderAsync(updatesToInstall_1[i].ProviderName)];
                                    case 1: return [4 /*yield*/, (_a.sent()).InstallRadioUpdateAsync(updatesToInstall_1[i], updateProgressWrapper, updateAction)];
                                    case 2:
                                        updateResult = _a.sent();
                                        //Wait between updates
                                        return [4 /*yield*/, timeout(5000)];
                                    case 3:
                                        //Wait between updates
                                        _a.sent();
                                        if (updateResult == DataFrame_1.Status.OK)
                                            this_1._controllerUpdates = this_1._controllerUpdates.filter(function (update) { return update.UpdateIdentifier != updatesToInstall_1[i].UpdateIdentifier; });
                                        result.push(updateResult);
                                        updateNumberRef_1[0]++;
                                        return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        i = 0;
                        _b.label = 9;
                    case 9:
                        if (!(i < updatesToInstall_1.length))
                            return [3 /*break*/, 12];
                        return [5 /*yield**/, _loop_1(i)];
                    case 10:
                        _b.sent();
                        _b.label = 11;
                    case 11:
                        i++;
                        return [3 /*break*/, 9];
                    case 12:
                        controlerUpdate_1 = this._controllerUpdates.find(function (update) { return update.UpdateType == IUpdateInfo_1.ControllerUpdateType.SoftwareUpdate; });
                        if (!(controlerUpdate_1 != null))
                            return [3 /*break*/, 14];
                        return [4 /*yield*/, this.UpdateControllerAsync(controlerUpdate_1.Update, updateProgressWrapper)];
                    case 13:
                        updateResult = _b.sent();
                        if (updateResult == DataFrame_1.Status.OK)
                            this._controllerUpdates = this._controllerUpdates.filter(function (update) { return update.UpdateIdentifier != controlerUpdate_1.UpdateIdentifier; });
                        result.push(updateResult);
                        updateNumberRef_1[0]++;
                        _b.label = 14;
                    case 14:
                        resultWithError = result.where(function (r) { return r instanceof FieldChangeResult_1.ResponseResult; }).toArray();
                        if (resultWithError != null && resultWithError.length != 0) {
                            errors_1 = "";
                            resultWithError.forEach(function (err) { return errors_1 += err.Type + ", "; });
                            this._appStateService.AllowHibernation();
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.UpdatesPartiallyInstalled, "Update installation finished - not all updates were successfully installed. Installation error codes: " + errors_1)];
                        }
                        this._appStateService.AllowHibernation();
                        return [2 /*return*/, DataFrame_1.Status.OK];
                    case 15: return [2 /*return*/];
                }
            });
        });
    };
    UpdatesService.prototype.UpdateControllerAsync = function (update, updateProgress) {
        var _a, _b, _c, _d, _e, _f;
        return __awaiter(this, void 0, Promise, function () {
            var _g, error_4, howManyDevices, extVersion, error_5, updateExtVersion, isNewApi, _h, error_6, intervalId_1, progressInfo_1, i_1, startTime, howLongToUpgrade_1, onePercentInTime_1, willEndAt_1, updatePromise, progressInfo_2, currentAuthData, result, executeCommandResult, i_2, intervalId_2, onePercent_1, startTime, howLongToUpgrade_2, onePercentInTime_2, willEndAt_2, updatePromise, err_2;
            var _this = this;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        _g = update.UpdateType;
                        switch (_g) {
                            case IUpdatesProvider_1.UpdateTypes.Container: return [3 /*break*/, 1];
                            case IUpdatesProvider_1.UpdateTypes.ContainerSoftware: return [3 /*break*/, 1];
                            case IUpdatesProvider_1.UpdateTypes.RuntimeFixingScript: return [3 /*break*/, 4];
                        }
                        return [3 /*break*/, 27];
                    case 1:
                        _j.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndHandleResponseAsync(new UpdateRequest(update.DownloadUri), this._updateRequestTimeout, function (resp) {
                                var progressInfo = new IUpdatesService_1.UpdateProgressInfo();
                                progressInfo.UpdatedResourceName = "Controller software";
                                switch (resp.Status) {
                                    case DataFrame_1.Status.MultiDataResponseStart:
                                        progressInfo.Status = IUpdatesService_1.UpdateStatus.PreparingForUpgrade;
                                        break;
                                    case DataFrame_1.Status.MultiDataResponse:
                                        if (resp.Data == null) {
                                            _this._logger.Warning(UpdatesService.ServiceName, "Recived update response without data! URI: " + update.DownloadUri);
                                            return;
                                        }
                                        progressInfo.Percentage = resp.Data.Progress;
                                        switch (resp.Data.State) {
                                            case IUpdatesService_1.UpdateState.CheckingApplicability:
                                            case IUpdatesService_1.UpdateState.CheckingIntegrity:
                                            case IUpdatesService_1.UpdateState.CheckingPackageIntegrity:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.CheckingPackage;
                                                break;
                                            case IUpdatesService_1.UpdateState.CreatingBackup:
                                            case IUpdatesService_1.UpdateState.MigratingData:
                                            case IUpdatesService_1.UpdateState.Removing:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.MovingData;
                                                break;
                                            case IUpdatesService_1.UpdateState.Deploying:
                                            case IUpdatesService_1.UpdateState.Installing:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.Upgrading;
                                                break;
                                            case IUpdatesService_1.UpdateState.Downloading:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.DownloadingPackage;
                                                break;
                                            case IUpdatesService_1.UpdateState.Error:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.Error;
                                                break;
                                            case IUpdatesService_1.UpdateState.Installed:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.Upgraded;
                                                break;
                                            case IUpdatesService_1.UpdateState.PreparingSystem:
                                            case IUpdatesService_1.UpdateState.ReadyToDownload:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.PreparingForUpgrade;
                                                break;
                                            case IUpdatesService_1.UpdateState.UndoingInstallation:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.InstallationStopped;
                                                break;
                                            case IUpdatesService_1.UpdateState.Unpackaging:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.MovingData;
                                                break;
                                            case IUpdatesService_1.UpdateState.WaitingForUser:
                                                progressInfo.Status = IUpdatesService_1.UpdateStatus.Upgrading;
                                                break;
                                        }
                                        break;
                                    case DataFrame_1.Status.MultiDataResponseStop:
                                        progressInfo.Status = IUpdatesService_1.UpdateStatus.OK;
                                        break;
                                }
                                updateProgress(progressInfo);
                            }, false))];
                    case 2:
                        _j.sent();
                        return [2 /*return*/, DataFrame_1.Status.OK];
                    case 3:
                        error_4 = _j.sent();
                        return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Cannot process update, error: " + error_4)];
                    case 4:
                        howManyDevices = 10;
                        extVersion = "n/a";
                        _j.label = 5;
                    case 5:
                        _j.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, this._extensionService.GetExtensionsInfoAsync()];
                    case 6:
                        extVersion = (_j.sent()).first(function (ext) { return ext.ExtensionGuid == "f4f45dac-beda-441a-8d29-efc6dc977cd1"; }).ExtensionVersion;
                        return [3 /*break*/, 8];
                    case 7:
                        error_5 = _j.sent();
                        this._logger.Warning("Cannot get protocol name! error: " + error_5);
                        return [3 /*break*/, 8];
                    case 8:
                        updateExtVersion = extVersion;
                        _h = parseFloat;
                        return [4 /*yield*/, this._updateProviders.GetSoftwareRuntimeInfoAsync()];
                    case 9:
                        isNewApi = _h.apply(void 0, [(_j.sent()).RuntimeVersion]) >= 2.0 ? true : (parseFloat(updateExtVersion) >= 1.2201125);
                        _j.label = 10;
                    case 10:
                        _j.trys.push([10, 12, , 13]);
                        return [4 /*yield*/, Api_1.Api.Get(DevicesService_1.DevicesService.ServiceName).GetDevicesAsync()];
                    case 11:
                        howManyDevices = (_j.sent()).length;
                        return [3 /*break*/, 13];
                    case 12:
                        error_6 = _j.sent();
                        this._logger.Warning(UpdatesService.ServiceName, "Cannot get number of devices in system! Error: " + error_6 + ". Using default value of 10 devices.");
                        return [3 /*break*/, 13];
                    case 13:
                        if (!isNewApi)
                            return [3 /*break*/, 15];
                        progressInfo_1 = new IUpdatesService_1.UpdateProgressInfo();
                        progressInfo_1.UpdatedResourceName = "Controller software";
                        progressInfo_1.Percentage = 1;
                        progressInfo_1.Status = IUpdatesService_1.UpdateStatus.PreparingForUpgrade;
                        updateProgress(progressInfo_1);
                        i_1 = 2;
                        startTime = Date.now();
                        howLongToUpgrade_1 = (howManyDevices * 900) + 800000;
                        onePercentInTime_1 = howLongToUpgrade_1 / 100;
                        willEndAt_1 = startTime + howLongToUpgrade_1;
                        updatePromise = new Promise(function (resolve, reject) {
                            return __awaiter(_this, void 0, void 0, function () {
                                var OnReturnedFromSuspensionHandler_1, result, error_7;
                                var _this = this;
                                var _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            _b.trys.push([0, 2, , 3]);
                                            OnReturnedFromSuspensionHandler_1 = function () {
                                                _this._appStateService.OnReturnedFromSuspension().Unsubscribe(OnReturnedFromSuspensionHandler_1);
                                                if (Date.now() > willEndAt_1) {
                                                    clearInterval(intervalId_1);
                                                    _this._logger.Debug("Update already finished!");
                                                    progressInfo_1.Percentage = 100;
                                                    progressInfo_1.Status = IUpdatesService_1.UpdateStatus.Upgraded;
                                                    updateProgress(progressInfo_1);
                                                    resolve(DataFrame_1.Status.OK);
                                                }
                                                else {
                                                    var msToEnd = (willEndAt_1 - Date.now());
                                                    if (msToEnd < howLongToUpgrade_1) {
                                                        i_1 = (95 - (msToEnd / onePercentInTime_1));
                                                    }
                                                    else {
                                                        clearInterval(intervalId_1);
                                                        intervalId_1 = setInterval(function () {
                                                            clearInterval(intervalId_1);
                                                            progressInfo_1.Percentage = 100;
                                                            progressInfo_1.Status = IUpdatesService_1.UpdateStatus.Upgraded;
                                                            updateProgress(progressInfo_1);
                                                            resolve(DataFrame_1.Status.OK);
                                                        }, msToEnd);
                                                    }
                                                }
                                            };
                                            this._appStateService.OnReturnedFromSuspension().Subscribe(OnReturnedFromSuspensionHandler_1);
                                            intervalId_1 = setInterval(function () {
                                                if (i_1 > 99) {
                                                    clearInterval(intervalId_1);
                                                    progressInfo_1.Percentage = 100;
                                                    progressInfo_1.Status = IUpdatesService_1.UpdateStatus.Upgraded;
                                                    updateProgress(progressInfo_1);
                                                    resolve(DataFrame_1.Status.OK);
                                                }
                                                else {
                                                    var percent = i_1;
                                                    if (percent < 99) {
                                                        progressInfo_1.Percentage = percent;
                                                        progressInfo_1.Status = IUpdatesService_1.UpdateStatus.Upgrading;
                                                        updateProgress(progressInfo_1);
                                                    }
                                                }
                                                i_1++;
                                            }, onePercentInTime_1);
                                            return [4 /*yield*/, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new InstallRequest(update.DownloadUri), this._updateRequestTimeout, false))];
                                        case 1:
                                            result = _b.sent();
                                            if (result.Status != DataFrame_1.Status.OK) {
                                                clearInterval(intervalId_1);
                                                progressInfo_1.Percentage = 0;
                                                progressInfo_1.Status = IUpdatesService_1.UpdateStatus.InstallationError;
                                                updateProgress(progressInfo_1);
                                                this._logger.Debug(UpdatesService.ServiceName, "Update failed with error. Update response status: " + result.Status);
                                                resolve(new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Update failed with error. Update response status: " + result.Status));
                                            }
                                            return [3 /*break*/, 3];
                                        case 2:
                                            error_7 = _b.sent();
                                            this._logger.Debug(UpdatesService.ServiceName, "Update failed with error. " + error_7);
                                            progressInfo_1.Percentage = 0;
                                            progressInfo_1.Status = IUpdatesService_1.UpdateStatus.Error;
                                            updateProgress(progressInfo_1);
                                            clearInterval(intervalId_1);
                                            resolve(new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Update failed with error. " + error_7));
                                            return [3 /*break*/, 3];
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            });
                        });
                        return [4 /*yield*/, updatePromise];
                    case 14: return [2 /*return*/, _j.sent()];
                    case 15:
                        progressInfo_2 = new IUpdatesService_1.UpdateProgressInfo();
                        progressInfo_2.UpdatedResourceName = "Controller software";
                        progressInfo_2.Percentage = 1;
                        progressInfo_2.Status = IUpdatesService_1.UpdateStatus.PreparingForUpgrade;
                        updateProgress(progressInfo_2);
                        currentAuthData = this._connection.GetAuthorizationInfo();
                        if (currentAuthData == null)
                            return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Cannot process update. Cannot get current controller login credentials!")];
                        return [4 /*yield*/, ((_b = this._connection) === null || _b === void 0 ? void 0 : _b.SendAndWaitForResponseAsync(new LoginUserRequest({ Email: "support@support", Password: "support@" + currentAuthData.SerialNumber + ":" + currentAuthData.PIN }), 12000, false))];
                    case 16:
                        result = _j.sent();
                        if (!(result.Status === DataFrame_1.Status.OK))
                            return [3 /*break*/, 26];
                        progressInfo_2.Percentage = 1;
                        progressInfo_2.Status = IUpdatesService_1.UpdateStatus.PreparingForUpgrade;
                        updateProgress(progressInfo_2);
                        return [4 /*yield*/, ((_c = this._connection) === null || _c === void 0 ? void 0 : _c.SendAndWaitForResponseAsync(new ExecuteCommandRequest("rm /runtime/tmp/update.sh"), 12000, false))];
                    case 17:
                        executeCommandResult = _j.sent();
                        if (!(executeCommandResult.Status == DataFrame_1.Status.OK))
                            return [3 /*break*/, 26];
                        this._logger.Debug("Removed previous script");
                        progressInfo_2.Percentage = 2;
                        progressInfo_2.Status = IUpdatesService_1.UpdateStatus.PreparingForUpgrade;
                        updateProgress(progressInfo_2);
                        return [4 /*yield*/, ((_d = this._connection) === null || _d === void 0 ? void 0 : _d.SendAndWaitForResponseAsync(new ExecuteCommandRequest("wget " + update.DownloadUri + " -O /runtime/tmp/update.sh --no-check-certificate"), this._updateRequestTimeout, false))];
                    case 18:
                        executeCommandResult = _j.sent();
                        if (!(executeCommandResult.Status == DataFrame_1.Status.OK))
                            return [3 /*break*/, 25];
                        this._logger.Debug("Downloaded update script");
                        progressInfo_2.Percentage = 5;
                        progressInfo_2.Status = IUpdatesService_1.UpdateStatus.PreparingForUpgrade;
                        updateProgress(progressInfo_2);
                        _j.label = 19;
                    case 19:
                        _j.trys.push([19, 24, , 25]);
                        return [4 /*yield*/, ((_e = this._connection) === null || _e === void 0 ? void 0 : _e.SendAndWaitForResponseAsync(new ExecuteCommandRequest("chmod a+x /runtime/tmp/update.sh"), 12000, false))];
                    case 20:
                        executeCommandResult = _j.sent();
                        if (!(executeCommandResult.Status == DataFrame_1.Status.OK))
                            return [3 /*break*/, 22];
                        this._logger.Debug("Executed update script");
                        progressInfo_2.Percentage = 5;
                        progressInfo_2.Status = IUpdatesService_1.UpdateStatus.Upgrading;
                        updateProgress(progressInfo_2);
                        i_2 = 0;
                        onePercent_1 = 95 / 100.0;
                        startTime = Date.now();
                        howLongToUpgrade_2 = (howManyDevices * 900) + 1500000;
                        onePercentInTime_2 = howLongToUpgrade_2 / 95;
                        willEndAt_2 = startTime + howLongToUpgrade_2;
                        updatePromise = new Promise(function (resolve, reject) {
                            return __awaiter(_this, void 0, void 0, function () {
                                var OnReturnedFromSuspensionHandler_2;
                                var _this = this;
                                var _a;
                                return __generator(this, function (_b) {
                                    try {
                                        OnReturnedFromSuspensionHandler_2 = function () {
                                            _this._appStateService.OnReturnedFromSuspension().Unsubscribe(OnReturnedFromSuspensionHandler_2);
                                            if (Date.now() > willEndAt_2) {
                                                clearInterval(intervalId_2);
                                                _this._logger.Debug("Update already finished!");
                                                progressInfo_2.Percentage = 100;
                                                progressInfo_2.Status = IUpdatesService_1.UpdateStatus.Upgraded;
                                                updateProgress(progressInfo_2);
                                                resolve(DataFrame_1.Status.OK);
                                            }
                                            else {
                                                var msToEnd = (willEndAt_2 - Date.now());
                                                if (msToEnd < howLongToUpgrade_2) {
                                                    i_2 = (95 - (msToEnd / onePercentInTime_2));
                                                }
                                                else {
                                                    clearInterval(intervalId_2);
                                                    intervalId_2 = setInterval(function () {
                                                        clearInterval(intervalId_2);
                                                        progressInfo_2.Percentage = 100;
                                                        progressInfo_2.Status = IUpdatesService_1.UpdateStatus.Upgraded;
                                                        updateProgress(progressInfo_2);
                                                        resolve(DataFrame_1.Status.OK);
                                                    }, msToEnd);
                                                }
                                            }
                                        };
                                        this._appStateService.OnReturnedFromSuspension().Subscribe(OnReturnedFromSuspensionHandler_2);
                                        intervalId_2 = setInterval(function () {
                                            if (i_2 > 99) {
                                                clearInterval(intervalId_2);
                                                progressInfo_2.Percentage = 100;
                                                progressInfo_2.Status = IUpdatesService_1.UpdateStatus.Upgraded;
                                                updateProgress(progressInfo_2);
                                                resolve(DataFrame_1.Status.OK);
                                            }
                                            else {
                                                var percent = (5 + (i_2 * onePercent_1));
                                                ;
                                                if (percent < 99) {
                                                    progressInfo_2.Percentage = percent;
                                                    progressInfo_2.Status = IUpdatesService_1.UpdateStatus.Upgrading;
                                                    updateProgress(progressInfo_2);
                                                }
                                            }
                                            i_2++;
                                        }, onePercentInTime_2);
                                        (_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new ExecuteCommandRequest("/runtime/tmp/update.sh"), 12000, false);
                                    }
                                    catch (error) {
                                        resolve(new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Update failed with error. " + error));
                                    }
                                    return [2 /*return*/];
                                });
                            });
                        });
                        return [4 /*yield*/, updatePromise];
                    case 21: return [2 /*return*/, _j.sent()];
                    case 22:
                        progressInfo_2.Percentage = 0;
                        progressInfo_2.Status = IUpdatesService_1.UpdateStatus.InstallationError;
                        updateProgress(progressInfo_2);
                        return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Execution failed!")];
                    case 23: return [3 /*break*/, 25];
                    case 24:
                        err_2 = _j.sent();
                        (_f = this._connection) === null || _f === void 0 ? void 0 : _f.SendAndWaitForResponseAsync(new ExecuteCommandRequest("/runtime/scripts/restart_all.sh"), 12000, false);
                        return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Execution failed! Error " + err_2)];
                    case 25: return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Execution failed! Cannot clear old update script!")];
                    case 26: return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Execution failed! Cannot loggin using support account!")];
                    case 27: return [2 /*return*/, new FieldChangeResult_1.ResponseResult(IUpdatesService_1.UpdateErrorCode.CannotProcessUpdate, "Not supported update type, type: " + update.UpdateType)];
                }
            });
        });
    };
    UpdatesService.ServiceName = "UpdatesService";
    return UpdatesService;
}());
exports.UpdatesService = UpdatesService;
var CachedUpdateInfo = /** @class */ (function (_super) {
    __extends(CachedUpdateInfo, _super);
    function CachedUpdateInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.UpdateIdentifier = "";
        _this.ProviderName = "";
        _this.UpdateType = null;
        return _this;
    }
    return CachedUpdateInfo;
}(IUpdatesProvider_1.UpdateInfo));
/**
 * @type Class
 */
var ControllerUpdateNotAvailableInfo = /** @class */ (function () {
    function ControllerUpdateNotAvailableInfo() {
        this.UpdatedResourceName = "";
        this.CurrentResourceVersion = "";
        this.UpdateType = null;
        this.ResponseResult = null;
    }
    return ControllerUpdateNotAvailableInfo;
}());
exports.ControllerUpdateNotAvailableInfo = ControllerUpdateNotAvailableInfo;
var ControllerUpdate = /** @class */ (function () {
    function ControllerUpdate() {
        this._updateIdentifier = "";
        this._updateResourceName = "";
        this._updateType = null;
        this._currentResourceVersion = "";
        this._newResourceVersion = "";
        this._updateDescription = new Map();
    }
    Object.defineProperty(ControllerUpdate.prototype, "UpdateDescription", {
        get: function () {
            return this._updateDescription;
        },
        set: function (value) {
            this._updateDescription = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ControllerUpdate.prototype, "UpdateIdentifier", {
        get: function () {
            return this._updateIdentifier;
        },
        set: function (value) {
            this._updateIdentifier = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ControllerUpdate.prototype, "UpdatedResourceName", {
        get: function () {
            return this._updateResourceName;
        },
        set: function (value) {
            this._updateResourceName = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ControllerUpdate.prototype, "UpdateType", {
        get: function () {
            return this._updateType;
        },
        set: function (value) {
            this._updateType = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ControllerUpdate.prototype, "CurrentResourceVersion", {
        get: function () {
            return this._currentResourceVersion;
        },
        set: function (value) {
            this._currentResourceVersion = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ControllerUpdate.prototype, "NewResourceVersion", {
        get: function () {
            return this._newResourceVersion;
        },
        set: function (value) {
            this._newResourceVersion = value;
        },
        enumerable: false,
        configurable: true
    });
    return ControllerUpdate;
}());
var DeviceUpdate = /** @class */ (function () {
    function DeviceUpdate() {
        this._updatedResourceName = "";
        this._updateResourceGuid = "";
        this._protocol = "";
        this._protocolGuid = "";
        this._currentResourceVersion = "";
        this._newResourceVersion = "";
        this._isUpdateSafe = true;
        this._updateDescription = new Map();
    }
    Object.defineProperty(DeviceUpdate.prototype, "UpdateDescription", {
        get: function () {
            return this._updateDescription;
        },
        set: function (value) {
            this._updateDescription = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceUpdate.prototype, "UpdatedResourceName", {
        get: function () {
            return this._updatedResourceName;
        },
        set: function (value) {
            this._updatedResourceName = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceUpdate.prototype, "UpdateResourceGuid", {
        get: function () {
            return this._updateResourceGuid;
        },
        set: function (value) {
            this._updateResourceGuid = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceUpdate.prototype, "Protocol", {
        get: function () {
            return this._protocol;
        },
        set: function (value) {
            this._protocol = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceUpdate.prototype, "ProtocolGuid", {
        get: function () {
            return this._protocolGuid;
        },
        set: function (value) {
            this._protocolGuid = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceUpdate.prototype, "CurrentResourceVersion", {
        get: function () {
            return this._currentResourceVersion;
        },
        set: function (value) {
            this._currentResourceVersion = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceUpdate.prototype, "NewResourceVersion", {
        get: function () {
            return this._newResourceVersion;
        },
        set: function (value) {
            this._newResourceVersion = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceUpdate.prototype, "IsUpdateSafe", {
        get: function () {
            return this._isUpdateSafe;
        },
        set: function (value) {
            this._isUpdateSafe = value;
        },
        enumerable: false,
        configurable: true
    });
    return DeviceUpdate;
}());
//Install update
var UpdateRequest = /** @class */ (function (_super) {
    __extends(UpdateRequest, _super);
    function UpdateRequest(uri) {
        var _this = _super.call(this) || this;
        _this.Resource = "/updates/update/from/uri";
        _this.Method = DataFrame_1.Method.Post;
        _this.Data = uri;
        return _this;
    }
    return UpdateRequest;
}(DataFrame_1.DataFrame));
var UpdateStatusFrame = /** @class */ (function () {
    function UpdateStatusFrame() {
        this.ExpectedInstallationTime = 0;
        this.Guid = "";
        this.Package = new JsonPackageSchema();
        this.Progress = 0;
        this.State = IUpdatesService_1.UpdateState.PreparingSystem;
        this.UserInput = IUpdatesService_1.UserInput.Install;
    }
    return UpdateStatusFrame;
}());
var JsonPackageSchema = /** @class */ (function () {
    function JsonPackageSchema() {
        this.Package = new JsonPackage();
        this.Publisher = new Publisher();
    }
    return JsonPackageSchema;
}());
var JsonPackage = /** @class */ (function () {
    function JsonPackage() {
        this.CompatibleHardwareVersions = [];
        this.CompatibleOperatingSystems = [];
        this.CompatibleProcessorArch = [];
        this.CompatibleSoftwareVersions = [];
        this.DependencyRequiredExtensions = [];
        this.Description = new Map();
        this.Guid = "";
        this.Name = new Map();
        this.PackageAPIVersion = 0;
        this.PackageType = PackageType.Unknown;
        this.PackageVersion = 0;
        this.PublicationTime = Date.now().toString();
        this.PublisherGuid = "";
        this.RequiredDownloadDiskSpace = 0;
        this.RequiredInstallDiskSpace = 0;
        this.UpdateChannels = [];
    }
    return JsonPackage;
}());
var Hardware = /** @class */ (function () {
    function Hardware() {
        this.Guid = "";
        this.MaxVersion = 0;
        this.MinVersion = 0;
    }
    return Hardware;
}());
var OperatingSystem;
(function (OperatingSystem) {
    OperatingSystem[OperatingSystem["Windows"] = 0] = "Windows";
    OperatingSystem[OperatingSystem["Linux"] = 1] = "Linux";
    OperatingSystem[OperatingSystem["Unix"] = 2] = "Unix";
    OperatingSystem[OperatingSystem["OSX"] = 3] = "OSX";
    OperatingSystem[OperatingSystem["Android"] = 4] = "Android";
    OperatingSystem[OperatingSystem["iOS"] = 5] = "iOS";
    OperatingSystem[OperatingSystem["WindowsMobile"] = 6] = "WindowsMobile";
})(OperatingSystem || (OperatingSystem = {}));
var ProcessorArch;
(function (ProcessorArch) {
    ProcessorArch[ProcessorArch["Any"] = 0] = "Any";
    ProcessorArch[ProcessorArch["MIPS"] = 1] = "MIPS";
    ProcessorArch[ProcessorArch["ARM32"] = 2] = "ARM32";
    ProcessorArch[ProcessorArch["ARM64"] = 3] = "ARM64";
    ProcessorArch[ProcessorArch["IntelX86"] = 4] = "IntelX86";
    ProcessorArch[ProcessorArch["IntelX64"] = 5] = "IntelX64";
})(ProcessorArch || (ProcessorArch = {}));
var DependencyExtension = /** @class */ (function () {
    function DependencyExtension() {
        this.CompatibleVersions = 0;
        this.ExtensionGuid = 0;
        this.MaximumCompatibleVersion = 0;
        this.MinimumCompatibleVersion = 0;
    }
    return DependencyExtension;
}());
var PackageType;
(function (PackageType) {
    PackageType[PackageType["Unknown"] = 0] = "Unknown";
    PackageType[PackageType["Environment"] = 1] = "Environment";
    PackageType[PackageType["OperatingSystem"] = 2] = "OperatingSystem";
    PackageType[PackageType["Application"] = 3] = "Application";
    PackageType[PackageType["Extension"] = 4] = "Extension";
    PackageType[PackageType["HardwareFirmware"] = 5] = "HardwareFirmware";
    PackageType[PackageType["Script"] = 6] = "Script";
    PackageType[PackageType["Command"] = 7] = "Command";
})(PackageType || (PackageType = {}));
var Publisher = /** @class */ (function () {
    function Publisher() {
        this.Description = "";
        this.Email = "";
        this.Guid = "";
        this.Name = "";
        this.Phone = "";
        this.PublisherGuid = "";
        this.Webpage = "";
    }
    return Publisher;
}());
var InstallRequest = /** @class */ (function (_super) {
    __extends(InstallRequest, _super);
    function InstallRequest(uri) {
        var _this = _super.call(this) || this;
        _this.Resource = "/updates/install/from/url";
        _this.Method = DataFrame_1.Method.Put;
        _this.Data = uri;
        return _this;
    }
    return InstallRequest;
}(DataFrame_1.DataFrame));
var LoginUserRequest = /** @class */ (function (_super) {
    __extends(LoginUserRequest, _super);
    function LoginUserRequest(data) {
        var _this = _super.call(this) || this;
        _this.Resource = "/users/user/login";
        _this.Method = DataFrame_1.Method.Put;
        _this.Data = data;
        return _this;
    }
    return LoginUserRequest;
}(DataFrame_1.DataFrame));
var LoginUser = /** @class */ (function () {
    function LoginUser() {
        this.Email = "";
        this.Password = "";
    }
    return LoginUser;
}());
var ExecuteCommandRequest = /** @class */ (function (_super) {
    __extends(ExecuteCommandRequest, _super);
    function ExecuteCommandRequest(command) {
        var _this = _super.call(this) || this;
        _this.Resource = "/controller/runtime/execute";
        _this.Method = DataFrame_1.Method.Post;
        _this.Data = command;
        return _this;
    }
    return ExecuteCommandRequest;
}(DataFrame_1.DataFrame));
//# sourceMappingURL=UpdatesService.js.map