import { Status } from "../../DataFrame";
import { ResponseResult } from "../FieldChangeResult";
import { IPicture } from "../Pictures/IPicture";
import { AccessLevel, Gender, IUser, Localization } from "./IUser";
export declare class User implements IUser {
    private _guid;
    private _cloudGuid;
    private _name;
    private _surname;
    private _phone;
    private _email;
    private _isAccountOnline;
    private _isAccountActive;
    private _isAccountBanned;
    private _notificationChannels;
    private _gender;
    private _accessLevel;
    private _localization;
    get Guid(): string;
    set Guid(value: string);
    get CloudGuid(): string;
    set CloudGuid(value: string);
    get Name(): string;
    set Name(value: string);
    get Surname(): string;
    set Surname(value: string);
    get Phone(): string;
    set Phone(value: string);
    get AccessLevel(): AccessLevel;
    set AccessLevel(value: AccessLevel);
    get Email(): string;
    set Email(value: string);
    get IsAccountOnline(): boolean;
    set IsAccountOnline(value: boolean);
    get IsActive(): boolean;
    set IsActive(value: boolean);
    get IsBanned(): boolean;
    set IsBanned(value: boolean);
    get NotificationChannels(): string[];
    set NotificationChannels(value: string[]);
    get Gender(): Gender;
    set Gender(value: Gender);
    get Localization(): Localization;
    set Localization(value: Localization);
    GetUserProfilePictureAsync(): Promise<IPicture | ResponseResult<Status>>;
    SetUserProfilePictureAsync(base64PictureString: string): Promise<ResponseResult<Status>>;
}
